/**********************************************************************/
/* clnt_tcp.c									(Win32 Application)   */
/*                                         Microsoft Visual C++ 5.0	  */
/**********************************************************************/
/* Beispiel fr einen TCP-Client: Der Client ffnet die Verbindung    */
/* zum TCP-Server, dessen Adresse oder Name in der Dialogbox		  */
/* eingetragen wird. Alle im Feld Sendeneingegebenen Messages       */
/* werden zum Server bertragen und alle empfangenen Daten im Fenster */
/* Empfang ausgegeben.									          */
/* Im Statusfenster werden die gerade ausgefhrten WINSOCK-Funktionen */
/* angezeigt.                                                         */
/**********************************************************************/

#include <winsock.h>							// bindet auch windows.h ein!
#include <stdio.h>
#include "resource.h"							// Konstanten der Dialogfelder

SOCKET iClient = INVALID_SOCKET;				// ber diesen Socket wird die 
												// Verbindung zum Server hergestellt
#define WM_SOCKET (WM_USER + 1)					// private Windows-Nachrichten
#define SERVER_PORT 8000		 				// COM-Server Port, ber
												// den der Server erreichbar ist 



void ShowStatus( HWND hWnd, LPSTR lpMsg )		// Statusmeldungen protokollieren    
  {
	int iEntries;
	SendMessage( GetDlgItem( hWnd, IDC_STATUS ), 
               LB_ADDSTRING, 
               (WPARAM)-1, 
               (LPARAM)lpMsg );					// Neuen Eintrag hinzufgen
  
												
	iEntries = SendMessage( GetDlgItem( hWnd, IDC_STATUS ), 
               LB_GETCOUNT,
               0,                 
               0 );								// letzten Eintrag anzeigen
	SendMessage( GetDlgItem( hWnd, IDC_STATUS ), 
               LB_SETTOPINDEX,
               iEntries-1,           
               0 );
  }

												// Dialogprozedur des Hauptdialogs
BOOL WINAPI WSClientProc( HWND hWnd, UINT msg, WPARAM wP, LPARAM lP )
  {
    switch( msg )
	  { 
		case WM_INITDIALOG:						// Dialogfenster initialisiert
			SetWindowText( GetDlgItem( hWnd, IDC_DESTADDRESS ), "box" );
		break;

   		case WM_SOCKET:							// WINSOCK-Messages
		  { 
			switch( WSAGETSELECTEVENT(lP) )
			  {
				case FD_CONNECT:				// Nachricht von connect()
					ShowStatus( hWnd, "FD_CONNECT" );
					if( WSAGETSELECTERROR(lP) == 0 )
					  {
						EnableWindow( GetDlgItem( hWnd, IDC_CLOSE ), TRUE);
						EnableWindow( GetDlgItem( hWnd, IDC_CONNECT ), FALSE);
						EnableWindow( GetDlgItem( hWnd, IDC_SEND ), TRUE );
					  }
					else
					  { closesocket( iClient );
						iClient = INVALID_SOCKET;
						ShowStatus( hWnd, "Kein Server!" );
						EnableWindow( GetDlgItem( hWnd, IDC_CONNECT ), TRUE );
						EnableWindow( GetDlgItem( hWnd, IDC_CLOSE ), FALSE );
						EnableWindow( GetDlgItem( hWnd, IDC_SEND ), FALSE );
					  }
				break;







				case FD_READ:					// Daten eingegangen
				  { char readbytes[ 255 ];
					int  iReadLen;
					
					ShowStatus( hWnd, "FD_READ" );    
												// Alle verfgbaren Daten einlesen
					iReadLen = recv( iClient,readbytes,sizeof( readbytes )-1,0);
					if( iReadLen > 0 )
					  {	readbytes[ iReadLen ] = 0;
						SendMessage( GetDlgItem( hWnd, IDC_RECEIVE ), 
												 LB_ADDSTRING, 
												 (WPARAM)-1, 
												 (LPARAM)readbytes );
					  }
				  }
				break;

				case FD_CLOSE:					// Server hat Verbindung beendet
					ShowStatus( hWnd, "FD_CLOSE" );    
					EnableWindow( GetDlgItem( hWnd, IDC_SEND ), FALSE );
					EnableWindow( GetDlgItem( hWnd, IDC_CONNECT ), TRUE );
					EnableWindow( GetDlgItem( hWnd, IDC_CLOSE ), FALSE );
					closesocket( iClient );
					iClient = INVALID_SOCKET;
					break;
			  }
		  }
		break;

		case WM_COMMAND:						// Schaltflchen-Nachrichten
			switch( LOWORD( wP ) )
			  { case IDCANCEL:                  // CloseBox des Fensters
					EndDialog( hWnd, 0 );
				break; 
				
				case IDC_SEND:					// Daten senden
					if( iClient != INVALID_SOCKET )
					  {			  
						char Buffer[ 255 ];
						int  iSendLen;
						ShowStatus( hWnd, "FD_WRITE" );    
												// Serveradresse einlesen
						iSendLen = GetWindowText( GetDlgItem( hWnd, IDC_SENDDATA ), 
												  Buffer, 
												  sizeof( Buffer ) );
						ShowStatus( hWnd, "send()..." );    

						if( send( iClient, Buffer, iSendLen, 0 ) != SOCKET_ERROR )
						  { ShowStatus( hWnd, "... fertig" );    
							EnableWindow( GetDlgItem( hWnd, IDC_SEND ), TRUE );
						  }
						else 
						  { if( WSAGetLastError() == WSAEWOULDBLOCK )
								ShowStatus( hWnd, "... blockiert" ); 
							else
								ShowStatus( hWnd, "Fehler bei send()" ); 

							ShowStatus( hWnd, "closesocket()" ); 
							EnableWindow( GetDlgItem( hWnd, IDC_SEND ), TRUE );
							closesocket( iClient );
							iClient = INVALID_SOCKET;
							ShowStatus( hWnd, "Abbruch" ); 
						  }
					  }
				break;

				case IDC_CONNECT:
				  { SOCKADDR_IN sin;
					char remoteIP[64];
					char Buffer[80];			
												// Zieladresse auslesen
					GetWindowText( GetDlgItem( hWnd, IDC_DESTADDRESS ), 
								   remoteIP, 
								   sizeof( remoteIP ) );
                    
					memset( &sin, 0, sizeof( sin ) );
    				sin.sin_family = AF_INET;
					sin.sin_port = htons( SERVER_PORT );
          										// IP-Adresse -> Dot Notation
					ShowStatus( hWnd, "inet_addr()" );
					sin.sin_addr.s_addr = inet_addr( remoteIP );

												// Adresse ber DNS auflsen
					if( sin.sin_addr.s_addr == INADDR_NONE )	
					  {	HOSTENT *he;
						ShowStatus( hWnd, "gethostbyname()" );
						he = gethostbyname( remoteIP );
						if( he )
							sin.sin_addr.s_addr = *((DWORD*)he->h_addr);
						else
						  { ShowStatus( hWnd, "unglitige Internet-Adresse" );
							break;
						  }
					  }
												// Zieladresse protokollieren
					wsprintf( Buffer, "Adresse: 0x%08lx", 
							  ntohl( sin.sin_addr.s_addr ) );
					ShowStatus( hWnd, Buffer );
												// Socket erzeugen
					ShowStatus( hWnd, "socket()" );
					iClient = socket( AF_INET, SOCK_STREAM, 0 );
      
					if( iClient == INVALID_SOCKET )
					  { ShowStatus( hWnd, 
									"Fehler beim Allokieren des Connect-Sockets" );
						ShowStatus( hWnd,"Kein Verbindungsaufbau mglich" );
						break;
					  }

												// asynchronen Mode aktivieren
					ShowStatus( hWnd, "WSAAsyncSelect()" );
					if( WSAAsyncSelect( iClient, 
										  hWnd, 
										  WM_SOCKET, 
										  FD_CONNECT | 
										  FD_READ | 
										  FD_CLOSE) == 0 )
					  { ShowStatus( hWnd, "connect()" );
						if( connect(iClient,(SOCKADDR*)&sin,sizeof(sin))
							== SOCKET_ERROR)
						  { if( WSAGetLastError() == WSAEWOULDBLOCK )
							  { ShowStatus( hWnd, "Warte..." );
												// Senden-Schalflche deaktivieren
								EnableWindow( GetDlgItem( hWnd, IDC_SEND ), 
																FALSE );
								break;
							  }
						  }
					  }
					else 
						ShowStatus( hWnd, "Fehler bei WSAAsyncSelect()" );

					ShowStatus( hWnd,"closesocket()" );
					closesocket( iClient );
					iClient = INVALID_SOCKET;
				  } 
				break;				
				case IDC_CLOSE:
					ShowStatus( hWnd,"closesocket()" );
					closesocket( iClient );
					iClient = INVALID_SOCKET;
					EnableWindow( GetDlgItem( hWnd, IDC_CLOSE ), FALSE);
					EnableWindow( GetDlgItem( hWnd, IDC_CONNECT ), TRUE);
					EnableWindow( GetDlgItem( hWnd, IDC_SEND ), FALSE );
				break;				
			  }
		break;

		case WM_DESTROY:						// Fenster schlieen
	      { if( iClient != INVALID_SOCKET )		// Socket schlieen
				closesocket( iClient );
		  }
		break;
	  }
	return FALSE;
  }






/**********************************************************************/
/* WinMain: Haupteinsprungspunkt                                      */
/*--------------------------------------------------------------------*/
/* Parameter:    Standarddialogparameter                              */
/* Rckgabewert: 0                                                    */
/**********************************************************************/

int WINAPI WinMain(HINSTANCE hInstance, 
           HINSTANCE hPrevInstance, 
           LPSTR lpCmdLine,int  
           nShowCmd   )
  {
	WSADATA wsadata;
												// Version 1.1 der Winsock-DLL wird bentigt
	if( WSAStartup( MAKEWORD( 1,1 ), &wsadata ) == 0 )
      {
		DialogBox( hInstance,                   // Dialog anzeigen
				   MAKEINTRESOURCE(IDD_WSCLIENT ), 
                   NULL, 
                   WSClientProc );
		WSACleanup();                           // Winsock-DLL aufrumen
	  }
	else MessageBox( 0, 
					"Fehler beim Initialisieren der WINSOCK.DLL",
					"WSClient.EXE", 
					0 );
	return 0;
  }


