// DeviceDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "DigitalEA.h"
#include "DeviceDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDeviceDlg 


CDeviceDlg::CDeviceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDeviceDlg::IDD, pParent)
    {
    m_cfg.nTargetPort = 49153;
	//{{AFX_DATA_INIT(CDeviceDlg)
	m_strTarget = _T("");
	m_fDisable = FALSE;
	m_nId = 0;
	m_fSmartBox = FALSE;
	m_strInitList = _T("");
	m_nInit = -1;
	m_nTerminals = -1;
	m_flTimeBase = 0.0f;
	//}}AFX_DATA_INIT
    }


void CDeviceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDeviceDlg)
	DDX_Text(pDX, IDC_TARGET, m_strTarget);
	DDX_Check(pDX, IDC_DISABLE, m_fDisable);
	DDX_Text(pDX, IDC_NUMBER, m_nId);
	DDX_Check(pDX, IDC_SMARTBOX, m_fSmartBox);
	DDX_Text(pDX, IDC_INITLIST, m_strInitList);
	DDX_Radio(pDX, IDC_INIT_NONE, m_nInit);
	DDX_Radio(pDX, IDC_BIGBOX, m_nTerminals);
	DDX_Text(pDX, IDC_TIMEBASE, m_flTimeBase);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDeviceDlg, CDialog)
	//{{AFX_MSG_MAP(CDeviceDlg)
	ON_EN_CHANGE(IDC_INITLIST, OnChangeInitlist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDeviceDlg 

BOOL CDeviceDlg::OnInitDialog() 
    {
    WORD wMask;
	CDialog::OnInitDialog();
	
	// rgerliches Hin- und Herschaufeln, weil der Class-Wizard keine direkten
    // Verknpfungen mit den Elementen von m_cfg erstellen kann.
    // Na gut, einige Variablen haben aber auch sowieso keine besonders direkte
    // Entsprechung zu Dialogelementen.
    m_fDisable  = m_cfg.fDisable;
    m_fSmartBox = m_cfg.fSmartBox;
    m_nId       = m_cfg.nId;
    m_nTerminals = (m_cfg.wOutputs == 2) ? 1 : 0;
    m_flTimeBase = 0.1f * m_cfg.nPollStep;
    wMask = (1 << m_cfg.wOutputs) - 1;
    if( (m_cfg.wInitMask & wMask) == wMask )
        m_nInit = 1;    // alle
    else if( m_cfg.wInitMask == 0 )
        m_nInit = 0;    // keine
    else
        {               // Auswahl
        int n, n0;
        CString str;
        n0 = -1;
        wMask &= m_cfg.wInitMask;
        // Bitmuster in Aufzhlung umwandeln
        for( n = 0; wMask != 0; n++, wMask >>= 1 )
            if( wMask & 1 )
                {
                if( n0 == -1 )
                    n0 = n;
                if( (wMask & 2) == 0 )
                    {           // letztes (oder einziges) Bit einer Gruppe
                    if( n0 < n-1 )
                        str.Format( "%d-%d", n0, n );
                    else if( n0 < n )
                        str.Format( "%d; %d", n0, n );
                    else
                        str.Format( "%d", n );
                    if( !m_strInitList.IsEmpty() )
                        m_strInitList += "; ";
                    m_strInitList += str;
                    }
                }
            else
                n0 = -1;
        m_nInit = 2;
        }

    UpdateData( FALSE );
	return TRUE;  // return TRUE unless you set the focus to a control
	              // Ausnahme: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
    }

void CDeviceDlg::OnOK() 
    {
    UpdateData( TRUE );
    m_cfg.fDisable  = m_fDisable;
    m_cfg.fSmartBox = m_fSmartBox;
    m_cfg.nId       = m_nId;
    m_cfg.nPollStep = (int)floor(10 * m_flTimeBase + 0.5);
    if( m_cfg.nPollStep < 1 )
        m_cfg.nPollStep = 1;
    if( m_nTerminals == 1 )
        {
        m_cfg.wInputs = 2;
        m_cfg.wOutputs = 2;
        }
    else
        {
        m_cfg.wInputs = 12;
        m_cfg.wOutputs = 12;
        }
    WORD wMask = (1 << m_cfg.wOutputs) - 1;
    switch( m_nInit )
        {
        case 0:
            m_cfg.wInitMask = 0;
            break;
        case 1:
            m_cfg.wInitMask = wMask;
            break;
        case 2:
            {
            int n, n0;
            char *pc = (char *)(LPCTSTR)m_strInitList;
            
            // Aufzhlung in Bitmuster umsetzen.
            while( *pc && !isdigit( *pc ) )
                pc++;
            n0 = -1;
            m_cfg.wInitMask = 0;
            while( *pc )
                {
                n = strtol( pc, &pc, 10 );
                m_cfg.wInitMask |= (1 << n);
                if( n0 >= 0 )   // n ist ein Bereichsende
                    do  {
                        m_cfg.wInitMask |= (1 << n0);
                        }
                    while( ++n0 <= n );
                n0 = -1;
                while( *pc && !isdigit( *pc ) )
                    {
                    if( *pc == '-' )
                        n0 = n; // n war ein Bereichsanfang
                    pc++;
                    }
                }
            m_cfg.wInitMask &= wMask;
            break;
            }
        }
	CDialog::OnOK();
    }

void CDeviceDlg::OnChangeInitlist() 
    {
    CheckRadioButton( IDC_INIT_NONE, IDC_INIT_ENUM, IDC_INIT_ENUM );
    }
