// DigitalEA.cpp : Legt das Klassenverhalten fr die Anwendung fest.
//

#include "stdafx.h"
#include "DigitalEA.h"
#include "DigitalEADlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CDigitalEAApp

BEGIN_MESSAGE_MAP(CDigitalEAApp, CWinApp)
	//{{AFX_MSG_MAP(CDigitalEAApp)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDigitalEAApp Konstruktion

CDigitalEAApp::CDigitalEAApp()
    {
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen
	// Alle wichtigen Initialisierungen in InitInstance platzieren
    }

/////////////////////////////////////////////////////////////////////////////
// Das einzige CDigitalEAApp-Objekt

CDigitalEAApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CDigitalEAApp Initialisierung

BOOL CDigitalEAApp::InitInstance()
    {

    // Winsock initialisieren.
	if (!AfxSocketInit())
        {
        AfxMessageBox( IDP_SOCKETS_INIT_FAILED );
        return FALSE;
        }

	AfxEnableControlContainer();

	// Standardinitialisierung
	// Wenn Sie diese Funktionen nicht nutzen und die Gre Ihrer fertigen 
	//  ausfhrbaren Datei reduzieren wollen, sollten Sie die nachfolgenden
	//  spezifischen Initialisierungsroutinen, die Sie nicht bentigen, entfernen.

#ifdef _AFXDLL
	Enable3dControls();			// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
#else
	Enable3dControlsStatic();	// Diese Funktion bei statischen MFC-Anbindungen aufrufen
#endif
   
    // Registry statt .ini-File verwenden.
    SetRegistryKey(_T("Wiesemann & Theis"));

    // Konfigurationsdaten, d. h. zu kontaktierende Server, aus der Registry
    // bzw. aus dem ini-File lesen.
    CDeaServ *pdea;
    CString strSection, strHost;
    CServerConfig cfg;      
    int nTargets;

    nTargets = GetProfileInt( "Settings", "Targets", 0 );
    while( nTargets-- )
        {
        strSection.Format( "Target%d", nTargets );
        strHost = GetProfileString( strSection, "Host", "127.0.0.1" );
        cfg.nId = GetProfileInt( strSection, "ID", CDeaServ::g_nCount + 1 );
        // Fr die brigen Werte hat der Konstruktor sinnvolle Defaults vorgeschlagen.
        cfg.nTargetPort = GetProfileInt( strSection, "Port",     cfg.nTargetPort );
        cfg.fSmartBox   = GetProfileInt( strSection, "Type",     cfg.fSmartBox );
        cfg.fDisable    = GetProfileInt( strSection, "Disable",  cfg.fDisable );
        cfg.nPollStep   = GetProfileInt( strSection, "PollStep", cfg.nPollStep );
        cfg.wInputs     = GetProfileInt( strSection, "Inputs",   cfg.wInputs );
        cfg.wOutputs    = GetProfileInt( strSection, "Outputs",  cfg.wOutputs );
        cfg.wInitMask   = GetProfileInt( strSection, "InitMask", cfg.wInitMask );
        pdea = new CDeaServ( strHost, cfg );
        }

    // Unser Fenster, d. h. den Hauptdialog, erzeugen.
	CDigitalEADlg dlg;
	m_pMainWnd = &dlg;
	dlg.DoModal();

    // Server-Objekte wegwerfen.
    while( CDeaServ::g_root != NULL )
        delete CDeaServ::g_root;

	// Da das Dialogfeld geschlossen wurde, FALSE zurckliefern, so dass wir die
	//  Anwendung verlassen, anstatt das Nachrichtensystem der Anwendung zu starten.
	return FALSE;
    }



// Server-Konfiguration in die Registry zurckschreiben.

void CDigitalEAApp::SaveSettings()
    {
    CDeaServ *pdea;
    int nTargets = 0;
    CString strSection;

    WriteProfileInt( "Settings", "Targets", CDeaServ::g_nCount );
    for( pdea = CDeaServ::g_root; pdea != NULL; pdea = pdea->m_next )
        {
        strSection.Format( "Target%d", nTargets++ );
        WriteProfileString( strSection, "Host",  pdea->m_strTarget );
        WriteProfileInt( strSection, "ID",       pdea->m_cfg.nId );
        WriteProfileInt( strSection, "Type",     pdea->m_cfg.fSmartBox ? 1 : 0 );
        WriteProfileInt( strSection, "Disable",  pdea->m_cfg.fDisable ? 1 : 0 );
        WriteProfileInt( strSection, "Port",     pdea->m_cfg.nTargetPort );
        WriteProfileInt( strSection, "PollStep", pdea->m_cfg.nPollStep );
        WriteProfileInt( strSection, "Inputs",   pdea->m_cfg.wInputs );
        WriteProfileInt( strSection, "Outputs",  pdea->m_cfg.wOutputs );
        WriteProfileInt( strSection, "InitMask", pdea->m_cfg.wInitMask );
        }
    }


// berladene Funktionen, mit deren Hilfe die Profileinstellungen unter
// HKEY_LOCAL_MACHINE statt HKEY_CURRENT_USER landen.

void CDigitalEAApp::SetRegistryKey(LPCTSTR lpszRegistryKey )
    {
    HKEY    hKey;
    DWORD  dwDisp;
    CString str;

    str.LoadString( IDS_REGKEY_TEMPLATE );
    m_strKey.Format( str, lpszRegistryKey );

    if( RegCreateKeyEx( HKEY_LOCAL_MACHINE, m_strKey, 0, NULL, 0,
            KEY_ALL_ACCESS, NULL, &hKey, &dwDisp ) == ERROR_SUCCESS )
        RegCloseKey( hKey );
    }

UINT CDigitalEAApp::GetProfileInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, int nDefault)
    {
    HKEY    hKey;
    DWORD  dwSize, dwValue;
    LONG    lResult;
    CString strKey = m_strKey + "\\" + lpszSection;

    if( RegOpenKeyEx( HKEY_LOCAL_MACHINE, strKey, 0, 
            KEY_READ, &hKey ) == ERROR_SUCCESS )
        {
        dwSize = sizeof( dwValue );
        lResult = RegQueryValueEx( hKey, lpszEntry, NULL, NULL, 
                (LPBYTE)&dwValue, &dwSize );
        RegCloseKey( hKey );
        if( lResult == ERROR_SUCCESS )
            return dwValue;
        }
    return nDefault;
    }

CString CDigitalEAApp::GetProfileString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszDefault)
    {
    HKEY    hKey;
    TCHAR  szBuf[ 256 ];
    DWORD  dwSize;
    LONG    lResult;
    CString strKey = m_strKey + "\\" + lpszSection;

    if( RegOpenKeyEx( HKEY_LOCAL_MACHINE, strKey, 0, 
            KEY_READ, &hKey ) == ERROR_SUCCESS )
        {
        dwSize = sizeof( szBuf );
        lResult = RegQueryValueEx( hKey, lpszEntry, NULL, NULL, 
                (LPBYTE)&szBuf, &dwSize );
        RegCloseKey( hKey );
        if( lResult == ERROR_SUCCESS )
            return szBuf;
        }
    return lpszDefault;
    }

BOOL CDigitalEAApp::WriteProfileString(LPCTSTR lpszSection, LPCTSTR lpszEntry, LPCTSTR lpszValue)
    {
    HKEY    hKey, hKey2;
    DWORD  dwDisp;
    BOOL    fResult = FALSE;

    if( RegOpenKeyEx( HKEY_LOCAL_MACHINE, m_strKey, 0, 
            KEY_ALL_ACCESS, &hKey ) == ERROR_SUCCESS )
        {
        if( RegCreateKeyEx( hKey, lpszSection, 0, NULL, 0,
                KEY_ALL_ACCESS, NULL, &hKey2, &dwDisp ) == ERROR_SUCCESS )
            {
            if( RegSetValueEx( hKey2, lpszEntry, 0, REG_SZ, (PBYTE)lpszValue, 
                    ( lstrlen( lpszValue ) + 1 ) * sizeof(TCHAR) ) == ERROR_SUCCESS )
                fResult = TRUE;
            RegCloseKey( hKey2 );
            }
        RegCloseKey( hKey );
        }
    return fResult;
    }

BOOL CDigitalEAApp::WriteProfileInt(LPCTSTR lpszSection, LPCTSTR lpszEntry, int nValue)
    {
    HKEY    hKey, hKey2;
    DWORD  dwDisp;
    BOOL    fResult = FALSE;

    if( RegOpenKeyEx( HKEY_LOCAL_MACHINE, m_strKey, 0, 
            KEY_ALL_ACCESS, &hKey ) == ERROR_SUCCESS )
        {
        if( RegCreateKeyEx( hKey, lpszSection, 0, NULL, 0,
                KEY_ALL_ACCESS, NULL, &hKey2, &dwDisp ) == ERROR_SUCCESS )
            {
            if( RegSetValueEx( hKey2, lpszEntry, 0, REG_DWORD, (PBYTE)&nValue, 
                    sizeof(DWORD) ) == ERROR_SUCCESS )
                fResult = TRUE;
            RegCloseKey( hKey2 );
            }
        RegCloseKey( hKey );
        }
    return fResult;
    }

