using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using System.Text;


namespace Client
{
	/// <summary>
	/// Summary for Form1.
	/// </summary>
	public class mainWindow : System.Windows.Forms.Form
	{	// All elements of the application
		private System.Windows.Forms.CheckBox cb_Output0;
		private System.Windows.Forms.CheckBox cb_Output1;
		private System.Windows.Forms.CheckBox cb_Input0;
		private System.Windows.Forms.CheckBox cb_Input1;
		private System.Windows.Forms.CheckBox cb_Polling_Counter;
		private System.Windows.Forms.CheckBox cb_Polling_Outputs;
		private System.Windows.Forms.CheckBox cb_Polling_Inputs;
		private System.Windows.Forms.Button bt_Readall_Outputs;
		private System.Windows.Forms.Button bt_Readall_Inputs;
		private System.Windows.Forms.Button bt_Clear_Counter0;
		private System.Windows.Forms.Button bt_Clear_Counter1;
		private System.Windows.Forms.Button bt_Clearall_Counter;
		private System.Windows.Forms.Button bt_Read_Counter0;
		private System.Windows.Forms.Button bt_Read_Counter1;
		private System.Windows.Forms.Button bt_Readall_Counter;
		private System.Windows.Forms.Label lb_Counter0;
		private System.Windows.Forms.Label lb_Counter1;
		private System.Windows.Forms.Label lb_Intervall;
		private System.Windows.Forms.TextBox tb_Counter0;
		private System.Windows.Forms.TextBox tb_Counter1;
		private System.Windows.Forms.TextBox tb_Intervall;
		private System.Windows.Forms.Button bt_Connect;
		private System.Windows.Forms.Button bt_Disconnect;
		private System.Windows.Forms.TextBox tb_Password;
		private System.Windows.Forms.TextBox tb_Port;
		private System.Windows.Forms.TextBox tb_IP;
		private System.Windows.Forms.GroupBox gb_ioControlBox;
		private System.Windows.Forms.GroupBox gb_conControlBox;
		private System.Windows.Forms.StatusBar statusBar;
		/// <summary>
		/// </summary>
		private System.ComponentModel.Container components = null;
		// Global variables for the communication between Web-IO and client
		// over TCP
		private Socket client;
		private string rcv;
		private int intervall;
		private byte[] buffer = new byte[256];
		private System.Windows.Forms.Timer counter;
		private System.Windows.Forms.Timer outputs;
		private System.Windows.Forms.Timer inputs;

		public mainWindow()
		{
			//
			// Essential for windows Form-Designbackup
			//
			InitializeComponent();
			// Details of the application get inaccessible, which have still no 
			// sense to access
			gb_ioControlBox.Enabled = false;
			bt_Disconnect.Enabled = false;
			cb_Input0.Enabled = false;
			cb_Input1.Enabled = false;
			tb_Counter0.Enabled = false;
			tb_Counter1.Enabled = false;
		}

		/// <summary>
		/// Purge the used ressources
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.gb_ioControlBox = new System.Windows.Forms.GroupBox();
			this.lb_Intervall = new System.Windows.Forms.Label();
			this.lb_Counter1 = new System.Windows.Forms.Label();
			this.lb_Counter0 = new System.Windows.Forms.Label();
			this.tb_Intervall = new System.Windows.Forms.TextBox();
			this.tb_Counter1 = new System.Windows.Forms.TextBox();
			this.tb_Counter0 = new System.Windows.Forms.TextBox();
			this.bt_Readall_Counter = new System.Windows.Forms.Button();
			this.bt_Read_Counter1 = new System.Windows.Forms.Button();
			this.bt_Read_Counter0 = new System.Windows.Forms.Button();
			this.bt_Clearall_Counter = new System.Windows.Forms.Button();
			this.bt_Clear_Counter1 = new System.Windows.Forms.Button();
			this.bt_Clear_Counter0 = new System.Windows.Forms.Button();
			this.bt_Readall_Inputs = new System.Windows.Forms.Button();
			this.bt_Readall_Outputs = new System.Windows.Forms.Button();
			this.cb_Polling_Counter = new System.Windows.Forms.CheckBox();
			this.cb_Polling_Inputs = new System.Windows.Forms.CheckBox();
			this.cb_Polling_Outputs = new System.Windows.Forms.CheckBox();
			this.cb_Input1 = new System.Windows.Forms.CheckBox();
			this.cb_Input0 = new System.Windows.Forms.CheckBox();
			this.cb_Output1 = new System.Windows.Forms.CheckBox();
			this.cb_Output0 = new System.Windows.Forms.CheckBox();
			this.gb_conControlBox = new System.Windows.Forms.GroupBox();
			this.tb_IP = new System.Windows.Forms.TextBox();
			this.tb_Port = new System.Windows.Forms.TextBox();
			this.tb_Password = new System.Windows.Forms.TextBox();
			this.bt_Disconnect = new System.Windows.Forms.Button();
			this.bt_Connect = new System.Windows.Forms.Button();
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.gb_ioControlBox.SuspendLayout();
			this.gb_conControlBox.SuspendLayout();
			this.SuspendLayout();
			// 
			// gb_ioControlBox
			// 
			this.gb_ioControlBox.Controls.Add(this.lb_Intervall);
			this.gb_ioControlBox.Controls.Add(this.lb_Counter1);
			this.gb_ioControlBox.Controls.Add(this.lb_Counter0);
			this.gb_ioControlBox.Controls.Add(this.tb_Intervall);
			this.gb_ioControlBox.Controls.Add(this.tb_Counter1);
			this.gb_ioControlBox.Controls.Add(this.tb_Counter0);
			this.gb_ioControlBox.Controls.Add(this.bt_Readall_Counter);
			this.gb_ioControlBox.Controls.Add(this.bt_Read_Counter1);
			this.gb_ioControlBox.Controls.Add(this.bt_Read_Counter0);
			this.gb_ioControlBox.Controls.Add(this.bt_Clearall_Counter);
			this.gb_ioControlBox.Controls.Add(this.bt_Clear_Counter1);
			this.gb_ioControlBox.Controls.Add(this.bt_Clear_Counter0);
			this.gb_ioControlBox.Controls.Add(this.bt_Readall_Inputs);
			this.gb_ioControlBox.Controls.Add(this.bt_Readall_Outputs);
			this.gb_ioControlBox.Controls.Add(this.cb_Polling_Counter);
			this.gb_ioControlBox.Controls.Add(this.cb_Polling_Inputs);
			this.gb_ioControlBox.Controls.Add(this.cb_Polling_Outputs);
			this.gb_ioControlBox.Controls.Add(this.cb_Input1);
			this.gb_ioControlBox.Controls.Add(this.cb_Input0);
			this.gb_ioControlBox.Controls.Add(this.cb_Output1);
			this.gb_ioControlBox.Controls.Add(this.cb_Output0);
			this.gb_ioControlBox.Location = new System.Drawing.Point(8, 8);
			this.gb_ioControlBox.Name = "gb_ioControlBox";
			this.gb_ioControlBox.Size = new System.Drawing.Size(432, 160);
			this.gb_ioControlBox.TabIndex = 1;
			this.gb_ioControlBox.TabStop = false;
			this.gb_ioControlBox.Text = "Input/Output Control";
			// 
			// lb_Intervall
			// 
			this.lb_Intervall.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lb_Intervall.Location = new System.Drawing.Point(176, 120);
			this.lb_Intervall.Name = "lb_Intervall";
			this.lb_Intervall.Size = new System.Drawing.Size(64, 24);
			this.lb_Intervall.TabIndex = 21;
			this.lb_Intervall.Text = "Intervall";
			// 
			// lb_Counter1
			// 
			this.lb_Counter1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lb_Counter1.Location = new System.Drawing.Point(168, 56);
			this.lb_Counter1.Name = "lb_Counter1";
			this.lb_Counter1.Size = new System.Drawing.Size(64, 24);
			this.lb_Counter1.TabIndex = 20;
			this.lb_Counter1.Text = "Counter 1";
			// 
			// lb_Counter0
			// 
			this.lb_Counter0.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lb_Counter0.Location = new System.Drawing.Point(168, 24);
			this.lb_Counter0.Name = "lb_Counter0";
			this.lb_Counter0.Size = new System.Drawing.Size(64, 24);
			this.lb_Counter0.TabIndex = 19;
			this.lb_Counter0.Text = "Counter 0";
			// 
			// tb_Intervall
			// 
			this.tb_Intervall.Location = new System.Drawing.Point(240, 120);
			this.tb_Intervall.Name = "tb_Intervall";
			this.tb_Intervall.Size = new System.Drawing.Size(48, 20);
			this.tb_Intervall.TabIndex = 18;
			this.tb_Intervall.Text = "1000";
			this.tb_Intervall.TextChanged += new System.EventHandler(this.tb_Intervall_TextChanged);
			// 
			// tb_Counter1
			// 
			this.tb_Counter1.Location = new System.Drawing.Point(240, 56);
			this.tb_Counter1.Name = "tb_Counter1";
			this.tb_Counter1.Size = new System.Drawing.Size(48, 20);
			this.tb_Counter1.TabIndex = 17;
			this.tb_Counter1.Text = "0";
			// 
			// tb_Counter0
			// 
			this.tb_Counter0.Location = new System.Drawing.Point(240, 24);
			this.tb_Counter0.Name = "tb_Counter0";
			this.tb_Counter0.Size = new System.Drawing.Size(48, 20);
			this.tb_Counter0.TabIndex = 16;
			this.tb_Counter0.Text = "0";
			// 
			// bt_Readall_Counter
			// 
			this.bt_Readall_Counter.Location = new System.Drawing.Point(304, 88);
			this.bt_Readall_Counter.Name = "bt_Readall_Counter";
			this.bt_Readall_Counter.Size = new System.Drawing.Size(56, 23);
			this.bt_Readall_Counter.TabIndex = 14;
			this.bt_Readall_Counter.Text = "Read all";
			this.bt_Readall_Counter.Click += new System.EventHandler(this.bt_Readall_Counter_Click);
			// 
			// bt_Read_Counter1
			// 
			this.bt_Read_Counter1.Location = new System.Drawing.Point(304, 56);
			this.bt_Read_Counter1.Name = "bt_Read_Counter1";
			this.bt_Read_Counter1.Size = new System.Drawing.Size(56, 23);
			this.bt_Read_Counter1.TabIndex = 13;
			this.bt_Read_Counter1.Text = "Read";
			this.bt_Read_Counter1.Click += new System.EventHandler(this.bt_Read_Counter1_Click);
			// 
			// bt_Read_Counter0
			// 
			this.bt_Read_Counter0.Location = new System.Drawing.Point(304, 24);
			this.bt_Read_Counter0.Name = "bt_Read_Counter0";
			this.bt_Read_Counter0.Size = new System.Drawing.Size(56, 23);
			this.bt_Read_Counter0.TabIndex = 12;
			this.bt_Read_Counter0.Text = "Read";
			this.bt_Read_Counter0.Click += new System.EventHandler(this.bt_Read_Counter0_Click);
			// 
			// bt_Clearall_Counter
			// 
			this.bt_Clearall_Counter.Location = new System.Drawing.Point(368, 88);
			this.bt_Clearall_Counter.Name = "bt_Clearall_Counter";
			this.bt_Clearall_Counter.Size = new System.Drawing.Size(56, 23);
			this.bt_Clearall_Counter.TabIndex = 11;
			this.bt_Clearall_Counter.Text = "Clear all";
			this.bt_Clearall_Counter.Click += new System.EventHandler(this.bt_Clearall_Counter_Click);
			// 
			// bt_Clear_Counter1
			// 
			this.bt_Clear_Counter1.Location = new System.Drawing.Point(368, 56);
			this.bt_Clear_Counter1.Name = "bt_Clear_Counter1";
			this.bt_Clear_Counter1.Size = new System.Drawing.Size(56, 23);
			this.bt_Clear_Counter1.TabIndex = 10;
			this.bt_Clear_Counter1.Text = "Clear";
			this.bt_Clear_Counter1.Click += new System.EventHandler(this.bt_Clear_Counter1_Click);
			// 
			// bt_Clear_Counter0
			// 
			this.bt_Clear_Counter0.Location = new System.Drawing.Point(368, 24);
			this.bt_Clear_Counter0.Name = "bt_Clear_Counter0";
			this.bt_Clear_Counter0.Size = new System.Drawing.Size(56, 23);
			this.bt_Clear_Counter0.TabIndex = 9;
			this.bt_Clear_Counter0.Text = "Clear";
			this.bt_Clear_Counter0.Click += new System.EventHandler(this.bt_Clear_Counter0_Click);
			// 
			// bt_Readall_Inputs
			// 
			this.bt_Readall_Inputs.Location = new System.Drawing.Point(104, 80);
			this.bt_Readall_Inputs.Name = "bt_Readall_Inputs";
			this.bt_Readall_Inputs.TabIndex = 8;
			this.bt_Readall_Inputs.Text = "Read all";
			this.bt_Readall_Inputs.Click += new System.EventHandler(this.bt_Readall_Inputs_Click);
			// 
			// bt_Readall_Outputs
			// 
			this.bt_Readall_Outputs.Location = new System.Drawing.Point(16, 80);
			this.bt_Readall_Outputs.Name = "bt_Readall_Outputs";
			this.bt_Readall_Outputs.TabIndex = 7;
			this.bt_Readall_Outputs.Text = "Read all";
			this.bt_Readall_Outputs.Click += new System.EventHandler(this.bt_Readall_Outputs_Click);
			// 
			// cb_Polling_Counter
			// 
			this.cb_Polling_Counter.Location = new System.Drawing.Point(296, 120);
			this.cb_Polling_Counter.Name = "cb_Polling_Counter";
			this.cb_Polling_Counter.Size = new System.Drawing.Size(64, 24);
			this.cb_Polling_Counter.TabIndex = 6;
			this.cb_Polling_Counter.Text = "Polling";
			this.cb_Polling_Counter.CheckedChanged += new System.EventHandler(this.cb_Polling_Counter_CheckedChanged);
			// 
			// cb_Polling_Inputs
			// 
			this.cb_Polling_Inputs.Location = new System.Drawing.Point(104, 120);
			this.cb_Polling_Inputs.Name = "cb_Polling_Inputs";
			this.cb_Polling_Inputs.Size = new System.Drawing.Size(80, 24);
			this.cb_Polling_Inputs.TabIndex = 5;
			this.cb_Polling_Inputs.Text = "Polling";
			this.cb_Polling_Inputs.CheckedChanged += new System.EventHandler(this.cb_Polling_Inputs_CheckedChanged);
			// 
			// cb_Polling_Outputs
			// 
			this.cb_Polling_Outputs.Location = new System.Drawing.Point(16, 120);
			this.cb_Polling_Outputs.Name = "cb_Polling_Outputs";
			this.cb_Polling_Outputs.Size = new System.Drawing.Size(80, 24);
			this.cb_Polling_Outputs.TabIndex = 4;
			this.cb_Polling_Outputs.Text = "Polling";
			this.cb_Polling_Outputs.CheckedChanged += new System.EventHandler(this.cb_Polling_Outputs_CheckedChanged);
			// 
			// cb_Input1
			// 
			this.cb_Input1.Location = new System.Drawing.Point(104, 48);
			this.cb_Input1.Name = "cb_Input1";
			this.cb_Input1.Size = new System.Drawing.Size(80, 24);
			this.cb_Input1.TabIndex = 3;
			this.cb_Input1.Text = "Input 1";
			// 
			// cb_Input0
			// 
			this.cb_Input0.Location = new System.Drawing.Point(104, 24);
			this.cb_Input0.Name = "cb_Input0";
			this.cb_Input0.Size = new System.Drawing.Size(80, 24);
			this.cb_Input0.TabIndex = 2;
			this.cb_Input0.Text = "Input 0";
			// 
			// cb_Output1
			// 
			this.cb_Output1.Location = new System.Drawing.Point(16, 48);
			this.cb_Output1.Name = "cb_Output1";
			this.cb_Output1.Size = new System.Drawing.Size(80, 24);
			this.cb_Output1.TabIndex = 1;
			this.cb_Output1.Text = "Output 1";
			this.cb_Output1.CheckedChanged += new System.EventHandler(this.cb_Output1_CheckedChanged);
			// 
			// cb_Output0
			// 
			this.cb_Output0.Location = new System.Drawing.Point(16, 24);
			this.cb_Output0.Name = "cb_Output0";
			this.cb_Output0.Size = new System.Drawing.Size(80, 24);
			this.cb_Output0.TabIndex = 0;
			this.cb_Output0.Text = "Output 0";
			this.cb_Output0.CheckedChanged += new System.EventHandler(this.cb_Output0_CheckedChanged);
			// 
			// gb_conControlBox
			// 
			this.gb_conControlBox.Controls.Add(this.tb_IP);
			this.gb_conControlBox.Controls.Add(this.tb_Port);
			this.gb_conControlBox.Controls.Add(this.tb_Password);
			this.gb_conControlBox.Controls.Add(this.bt_Disconnect);
			this.gb_conControlBox.Controls.Add(this.bt_Connect);
			this.gb_conControlBox.Location = new System.Drawing.Point(8, 168);
			this.gb_conControlBox.Name = "gb_conControlBox";
			this.gb_conControlBox.Size = new System.Drawing.Size(432, 80);
			this.gb_conControlBox.TabIndex = 2;
			this.gb_conControlBox.TabStop = false;
			this.gb_conControlBox.Text = "Connection Control";
			// 
			// tb_IP
			// 
			this.tb_IP.Location = new System.Drawing.Point(16, 48);
			this.tb_IP.Name = "tb_IP";
			this.tb_IP.Size = new System.Drawing.Size(136, 20);
			this.tb_IP.TabIndex = 21;
			this.tb_IP.Text = "";
			// 
			// tb_Port
			// 
			this.tb_Port.Location = new System.Drawing.Point(160, 48);
			this.tb_Port.Name = "tb_Port";
			this.tb_Port.Size = new System.Drawing.Size(64, 20);
			this.tb_Port.TabIndex = 20;
			this.tb_Port.Text = "0";
			// 
			// tb_Password
			// 
			this.tb_Password.Location = new System.Drawing.Point(232, 48);
			this.tb_Password.Name = "tb_Password";
			this.tb_Password.Size = new System.Drawing.Size(88, 20);
			this.tb_Password.TabIndex = 19;
			this.tb_Password.Text = "";
			// 
			// bt_Disconnect
			// 
			this.bt_Disconnect.Location = new System.Drawing.Point(336, 48);
			this.bt_Disconnect.Name = "bt_Disconnect";
			this.bt_Disconnect.Size = new System.Drawing.Size(88, 23);
			this.bt_Disconnect.TabIndex = 14;
			this.bt_Disconnect.Text = "Disconnect";
			this.bt_Disconnect.Click += new System.EventHandler(this.bt_Disconnect_Click);
			// 
			// bt_Connect
			// 
			this.bt_Connect.Location = new System.Drawing.Point(336, 16);
			this.bt_Connect.Name = "bt_Connect";
			this.bt_Connect.Size = new System.Drawing.Size(88, 23);
			this.bt_Connect.TabIndex = 13;
			this.bt_Connect.Text = "Connect";
			this.bt_Connect.Click += new System.EventHandler(this.bt_Connect_Click);
			// 
			// statusBar
			// 
			this.statusBar.Font = new System.Drawing.Font("Times New Roman", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.statusBar.Location = new System.Drawing.Point(0, 253);
			this.statusBar.Name = "statusBar";
			this.statusBar.Size = new System.Drawing.Size(448, 16);
			this.statusBar.TabIndex = 3;
			this.statusBar.Text = "Disconnected";
			// 
			// mainWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(448, 269);
			this.Controls.Add(this.statusBar);
			this.Controls.Add(this.gb_ioControlBox);
			this.Controls.Add(this.gb_conControlBox);
			this.Name = "mainWindow";
			this.Text = "WebIOClient";
			this.gb_ioControlBox.ResumeLayout(false);
			this.gb_conControlBox.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main and all implemented methods of the application
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new mainWindow());
		}
		// Send data to the Web-IO in an non-synchronously state 
		private void send(string data)
		{
			// The data in form of a string has to be convert into bytes 
			byte[] byteData = Encoding.ASCII.GetBytes(data);
			client.BeginSend(byteData, 0, byteData.Length, 0, new AsyncCallback(sendCallback), client);
		}
		// If the client is sending data, the sendCallback-method will be finish the 
		// transmission
		private void sendCallback(IAsyncResult ar)
		{
			try
			{	
				Socket tmp_client = (Socket) ar.AsyncState;
				int bytessend = tmp_client.EndSend(ar);
			}
			catch(Exception)
			{ statusBar.Text = "Error by sending"; }
		}
		// The receiveCallback-method will be call if data is arriving
		private void receiveCallback(IAsyncResult ar)
		{	// How much bytes has been received
			int bytesRead;
			try
			{	// If the data has arrived the non-synchronously transmission will be 
				// stoped and all data get convert into a string named "rcv"
				bytesRead = client.EndReceive(ar);
				rcv = string.Empty;
				rcv = Encoding.ASCII.GetString(buffer);
				// Now the receiveCallback() repeated and the receive message get handled
				client.BeginReceive(buffer, 0, 255, SocketFlags.None , new AsyncCallback(receiveCallback), client);
			}	// Occurs an error the connection will be closed 
			catch(Exception) 
			{ bytesRead = 0; }
			// If an error occurs, or bytes = 0, and the connection is allready existing 
			// shutdown the connection
			if(bytesRead == 0 && client.Connected)
				disconnect();
			// Else if the received message is not empty, switch into the case of output,
			// input or counter
			else if(rcv != null)
			{	// If the received message include a change of the outputs 
				if(rcv[0] == 'o')
				{	// Convert the Hex-Value into an Integer
					int i = Int32.Parse(rcv.Substring(7), System.Globalization.NumberStyles.HexNumber);
					// Set or unset the output number 0
					if((i & 1) == 1)
						cb_Output0.Checked = true;
					else
						cb_Output0.Checked = false;
					// Set or unset the output number 1
					if((i & 2) == 2)
						cb_Output1.Checked = true;
					else
						cb_Output1.Checked = false;
				}
				// If the received message include a change of the input
				if(rcv[0] == 'i')
				{	// Covert the hex-value into an integer
					int i = Int32.Parse(rcv.Substring(6), System.Globalization.NumberStyles.HexNumber);
					// Set or unset the input number 0
					if((i & 1) == 1)
						cb_Input0.Checked = true;
					else
						cb_Input0.Checked = false;
					// Set or unset the input number 1
					if((i & 2) == 2)
						cb_Input1.Checked = true;
					else
						cb_Input1.Checked = false;
				}
				// If the message deals with counter
				if(rcv[0] == 'c')
				{	// Update the counter number 0
					if(rcv[7] == '0')
						tb_Counter0.Text = rcv.Substring(9);
					// Update the counter number 1 
					if(rcv[7] == '1')
						tb_Counter1.Text = rcv.Substring(9);
					// Update all counter 
					if(rcv[7] == ';')
						readAndClearCounter(rcv.Substring(8));
				}
			}
		}
		// This method get an received string from the receiveCallback method, by what
		// the counterstate can be updated
		private void readAndClearCounter(string data)
		{
			int j = 0;
			// Because 12 counter can be read, we need an string for each one
			string[] counter = new string[12];
			for(int i = 0; i < data.Length-1; i++)
			{	// Each counter in the received string will be end with ";"
				if((data[i].CompareTo(';')) == 0)
					j++;
				else
					counter[j] += data[i].ToString();
			}
			// After all counterstates has been written into their specific string, update
			// the elements of the application
			tb_Counter0.Text = counter[0];
			tb_Counter1.Text = counter[1];
		}
		// All events of the timer will catched in this method
		private void timer_handler(object sender, System.EventArgs e)
		{	// Depending on an timer, initiate the polling of counter, outputs or inputs 
			if(sender == counter) bt_Readall_Counter_Click(sender, e);
			if(sender == outputs) bt_Readall_Outputs_Click(sender, e);
			if(sender == inputs) bt_Readall_Inputs_Click(sender, e);
		}
		// This callback-method will accessed if the client try to connect to the Web-IO
		// in an non-synchronously way 
		private void connectCallback(IAsyncResult ar)
		{
			try
			{
				client = (Socket) ar.AsyncState;
				// If everything succeeds complete the connection
				client.EndConnect(ar);
				// If the connection succeeds display a message
				statusBar.Text = "Connected!";
				// All parts of the application, which now can be used, get 
				// accessible and the connect-button get inaccessible
				gb_ioControlBox.Enabled = true;
				bt_Disconnect.Enabled = true;
				bt_Connect.Enabled = false;
				// The intervall of polling will be set to 1000ms
				intervall = 1000;
				client.BeginReceive(buffer, 0, 255, SocketFlags.None, new AsyncCallback(receiveCallback), client);
			}// else throw an error-message
			catch(Exception)
			{ disconnect(); statusBar.Text = "Error by connecting!"; }
		}
		// By a click on the connect-button, start the connection to the Web-IO
		private void bt_Connect_Click(object sender, System.EventArgs e)
		{
			try
			{	// If no IP or port has been entered, display a message
				if((tb_IP.Text != "") && (tb_Port.Text != ""))
				{	// Create an new socket and connect to the Web-IO
					client = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
					IPEndPoint ipep = new IPEndPoint(IPAddress.Parse(tb_IP.Text), int.Parse(tb_Port.Text));
					client.BeginConnect(ipep, new AsyncCallback(connectCallback), client);
				}
				else
					statusBar.Text = "IP and Port needed!";
			}
			catch(SocketException)
			{ statusBar.Text = "Connection not possible!"; }
		}
		
		private void disconnect()
		{
			try
			{	// For disconnect shutdown the connection on both sides and
				// close the socket of the client
				client.Shutdown(SocketShutdown.Both);
				client.Close();
				// If the connection is correctly shutdown, display a message
				statusBar.Text = "Disconnected!";
				// Enable the connect-button, and disable the Input/Output Controll and
				// the disconnect-button
				gb_ioControlBox.Enabled = false;
				bt_Disconnect.Enabled = false;
				bt_Connect.Enabled = true;
			}
			catch(Exception)
			{ statusBar.Text = "Not able to disconnect!"; }
		}

		// By click on the disconnect-button close the connection by call the 
		// method disconnect()
		private void bt_Disconnect_Click(object sender, System.EventArgs e)
		{
			disconnect();
		}
		// Change the state of output 0
		private void cb_Output0_CheckedChanged(object sender, System.EventArgs e)
		{	// If checkbox-output0 been checked, set output
			if(cb_Output0.Checked)
				send("GET /outputaccess0?PW=" + tb_Password.Text + "&State=ON&");
			// else unset output
			else
				send("GET /outputaccess0?PW=" + tb_Password.Text + "&State=OFF&");
		}
		// Change the state of output 1
		private void cb_Output1_CheckedChanged(object sender, System.EventArgs e)
		{	// If checkbox-output1 been checked, set output
			if(cb_Output1.Checked)
				send("GET /outputaccess1?PW=" + tb_Password.Text + "&State=ON&");
				// else unset output
			else
				send("GET /outputaccess1?PW=" + tb_Password.Text + "&State=OFF&");
		}
		// Check the state of all outputs
		private void bt_Readall_Outputs_Click(object sender, System.EventArgs e)
		{
			send("GET /output?PW=" + tb_Password.Text + "&");
		}
		// Check the state of all inputs
		private void bt_Readall_Inputs_Click(object sender, System.EventArgs e)
		{
			send("GET /input?PW=" + tb_Password.Text + "&");
		}
		// Read the state of counter 0
		private void bt_Read_Counter0_Click(object sender, System.EventArgs e)
		{	// The response from the Web-IO : counter<x>;<zaehler>
			send("GET /counter0?PW=" + tb_Password.Text + "&");
		}
		// Read the state of counter 1
		private void bt_Read_Counter1_Click(object sender, System.EventArgs e)
		{
			send("GET /counter1?PW=" + tb_Password.Text + "&");
		}
		// Update all counter by requesting the state of everyone
		private void bt_Readall_Counter_Click(object sender, System.EventArgs e)
		{
			send("GET /counter?PW=" + tb_Password.Text + "&");
		}
		// Reset counter 0
		private void bt_Clear_Counter0_Click(object sender, System.EventArgs e)
		{
			send("GET /counterclear0?PW=" + tb_Password.Text + "&");
		}
		// Reset counter 1
		private void bt_Clear_Counter1_Click(object sender, System.EventArgs e)
		{
			send("GET /counterclear1?PW=" + tb_Password.Text + "&");
		}
		// Clear all counter with one message
		private void bt_Clearall_Counter_Click(object sender, System.EventArgs e)
		{
			send("GET /counterclear?PW=" + tb_Password.Text + "&");
		}
		
		// Update the counter through polling
		private void cb_Polling_Counter_CheckedChanged(object sender, System.EventArgs e)
		{
			if(cb_Polling_Counter.Checked)
			{	// Initialize a timer and set the curent range
				counter = new System.Windows.Forms.Timer();
				counter.Interval = intervall;
				counter.Start();
				// Set the method, which catch the fired events of the timer
				counter.Tick += new EventHandler(timer_handler);
			}
			else// Stop the specific timer if checkbox is unchecked
				counter.Stop();
		}
		// Update the outputs through polling
		private void cb_Polling_Outputs_CheckedChanged(object sender, System.EventArgs e)
		{	// If checkbox checked
			if(cb_Polling_Outputs.Checked)
			{	// Initialize a timer and set the curent range
				outputs = new System.Windows.Forms.Timer();
				outputs.Interval = intervall;
				outputs.Start();
				// The fired events will be catched from timer_handler()
				outputs.Tick += new EventHandler(timer_handler);
			}
			else// Stop the specific Timer
				outputs.Stop();
		}
		// Update the inputs through polling
		private void cb_Polling_Inputs_CheckedChanged(object sender, System.EventArgs e)
		{
			if(cb_Polling_Inputs.Checked)
			{
				inputs = new System.Windows.Forms.Timer();
				inputs.Interval = intervall;
				inputs.Start();
				inputs.Tick += new EventHandler(timer_handler);
			}
			else
				inputs.Stop();
		}
		// Update the interval of the polling
		private void tb_Intervall_TextChanged(object sender, System.EventArgs e)
		{	// If a character has been typed for the range, break and display a message
			try
			{	// If the value is positiv and an integer
				if(Convert.ToInt32(tb_Intervall.Text) > 0)
				{	// set the new range for Polling
					intervall = Convert.ToInt32(tb_Intervall.Text);
					statusBar.Text = "New range: " + intervall.ToString() + " ms!";
				}
				else// else remember the user for a correct entry
					statusBar.Text = "Only positiv Integer allowed!";
			}
			catch(Exception)
			{ statusBar.Text = "Only positiv Integer allowed!"; }		
		}
	}
}
