/*******************************************************************************/
/* serv_tcp.cpp   										   (Win32 Application) */
/*                                                    Microsoft Visual C++ 5.0 */
/*******************************************************************************/
/* Beispielprogramm fr einen TCP-Server auf Port 7 (ECHO). Der Server akzep-  */
/* tiert mehrere Verbindungen und sendet das Echo der auf diesem Socket        */
/* empfangenen Daten an die Clients zurck, bis diese die Verbindung schlieen.*/
/*******************************************************************************/

#include <winsock.h>							// #include windows.h
#include <stdio.h>
#include "resource.h"							// Resourcen
#include "sockcpp.h"							// Deklaration der Klassen 

int  WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int );
long WINAPI WTcpServProc( HWND, unsigned, WORD wParam, LONG lParam );



long WINAPI WTcpServProc(
	HWND            hWnd,
	unsigned        message,
	WORD            wParam,
	LONG            lParam)
  {
    sockServerWnd	MyServer( hWnd );			// Klasse sockServerWnd laden
	MSG		msg;

	switch( message ) 
	  {	
		case WM_COMMAND:
			switch( wParam ) 
			  {	case ID_START:
					if( MyServer.Init()< 0 ) 
						break; 
					for( ;; )
					  {	if( !MyServer.HandleClient() )
					 	  {	if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE )) 
							  {	if( msg.message == WM_QUIT ) 
								  {	MyServer.CloseAllHandle();
									break;
								  }
								TranslateMessage( &msg );
								DispatchMessage( &msg );
							  }
						  }
						else
							MyServer.Action();
					  }
				break;

				case ID_EXIT:
				case IDCANCEL:
					DestroyWindow( hWnd );
				break;
			  }
		break;
			
		case WM_DESTROY:
			PostQuitMessage( 0 );
		break;

		default:
		break;
	  }
	return( 0 );
  }


int WINAPI WinMain(	HINSTANCE	hInstance,
	                HINSTANCE	hPrevInstance,
                	LPSTR		lpCmdLine,
                	int			nShowCmd       )
  {		
	WSADATA		wsadata;
												// init Winsock-DLL Version 1.1
	if( WSAStartup( MAKEWORD( 1,1 ), &wsadata ) == 0 )
	  {	DialogBox(	hInstance, 
					MAKEINTRESOURCE( IDD_WSSERVER ), 
					NULL, 
					(DLGPROC)WTcpServProc );
		WSACleanup();
	  }
	else
		MessageBox( 0, "Fehler beim Initialisieren der WINSOCK.DLL",
					   "WSClient.EXE", 0 );
	return (0);
  }


/**********************************************************************/
/* Memberfunktionen der Class sockcpp					              */
/**********************************************************************/

sockcpp::sockcpp()								// Konstruktor der Klasse sockcpp
  {	
	iStatus = 0;								// Standardinitialisierung
    for( int x = 0; x < MAX_SOCKETS; x++ ) 
		in_use[x] = 0;
  } 
sockcpp::~sockcpp()	{}							// Destruktor der Klasse sockcpp
  
int  sockcpp::Socket( int af, int type, int protocol )         
  {	
	iStatus = 0;        
    iMySock = socket( af,  type, protocol );
	if( iMySock < 0 )
		iStatus = -1;
	return( iStatus );
  }

int  sockcpp::Bind( u_short uPort )     
  {	
	addr.sin_family = AF_INET;
	addr.sin_port   = htons( uPort );
	addr.sin_addr.s_addr = 0;

	iStatus = bind( iMySock, (const struct sockaddr FAR *)&addr, sizeof(addr)); 
	return( iStatus );
  }

int  sockcpp::Listen( void )
  {	
	iStatus = listen( iMySock, 5 ); 
    in_use[0] = iMySock;
	return( iStatus );
  }

void sockcpp::Close( int SocHan )
  {	
	closesocket( SocHan );
  }

int sockcpp::HandleClient( void )
  {	int x;

	FD_ZERO( (fd_set FAR *)&readfds );
	seltime.tv_sec = 0;
	seltime.tv_usec = 100;
	FD_SET( iMySock, (fd_set FAR *)&readfds );
	
	for( x = 0; x < MAX_SOCKETS; x++) 
	   { if( in_use[x] ) 
		  	 FD_SET( in_use[x], (fd_set FAR *)&readfds );
	   }
	return( select(  MAX_SOCKETS,
			(fd_set FAR *)&readfds, (fd_set FAR *) 0, (fd_set FAR *) 0,
			(const struct timeval FAR *)&seltime ));
  }


void sockcpp::CloseAllHandle( void )
  {	
	int x;

	for( x = 0; x < MAX_SOCKETS; x++ ) 
 	   { if( in_use[x] && in_use[x] != iMySock )
	  	  	 Close( in_use[x] );
	   }
	Close( iMySock );
  }


int sockcpp::Accept( struct sockaddr_in *peer_in )
  {	
	int  ns, x;
	int  peersize = sizeof( sockaddr_in );	

	if((ns = accept( iMySock,
					 (struct sockaddr FAR *)peer_in, 
					 (LPINT)&peersize )) < 0 )
	  {	iStatus = ns;
		return( ns );
	  }
    for( x=0; x < MAX_SOCKETS; x++ )
       { if( in_use[x] == 0 )
           { in_use[x] = ns;
             break;
       }   }
	return( ns );
  }

int sockcpp::RecvClient( int iClient, LPSTR pBuffer, int iLenBuf )
  { int iLen = recv( in_use[iClient], pBuffer, iLenBuf, 0 );
	
	if( iLen <= 0 )
	  { (void) closesocket( in_use[iClient] );
        in_use[ iClient] = 0;
	  }
	return( iLen );	
  }

void sockcpp::SendClient( int iClient, LPSTR pBuffer, int iLenBuf )
  {	if( send( in_use[ iClient], pBuffer, iLenBuf, 0) < 0 )
	  { (void) closesocket( in_use[iClient] );
        in_use[ iClient ] = 0;
	  }
  }

int sockcpp::GetClient( int iClient )
  {  
	return( FD_ISSET( in_use[ iClient ], (fd_set FAR *)&readfds));
  }		
	
int sockcpp::CheckMySocket( int iClient )
  { if( in_use[iClient] != iMySock )
        return 1;
   return 0;
  }  

/**********************************************************************/
/* Memberfunktionen der Class sockServerWnd				              */
/**********************************************************************/

sockServerWnd::sockServerWnd( HWND hWnd ) : sockcpp()
  {												// Konstruktor der Klasse sockServerWnd	
	hWndClass  = hWnd;							// aktives Dialogfenster
  }

sockServerWnd::~sockServerWnd( ) {}				// Destruktor der Klasse sockServerWnd

int sockServerWnd::Init()
  {	
	ShowStatus( hWndClass, "socket()", ID_LISTING );
	if( Socket() < 0 ) 
	  {	ShowStatus( hWndClass, " failed.", ID_LISTING );
		return( -1 );
	  }
	
	ShowStatus( hWndClass, "bind()", ID_LISTING );
	if( Bind( ECHO_PORT ) < 0) 
	  {	Close( iMySock );
		ShowStatus( hWndClass, " failed.", ID_LISTING );
		return( -1 );
	  }
	
	ShowStatus( hWndClass, "listen()", ID_LISTING );
	if( Listen() < 0) 
	  {	Close( iMySock );
		ShowStatus( hWndClass, " failed.", ID_LISTING );
		return( -1 );
	  }
												// Senden-Schalflche deaktivieren
    EnableWindow( GetDlgItem( hWndClass, ID_START ), FALSE );
	return( 1 );
  }



void sockServerWnd::Action()
  {	int x;
	for( x = 0; x < MAX_SOCKETS; x++ ) 
	  {	if( GetClient( x ) )					// Data present ( test readfds )
		  {	ShowStatus( hWndClass, "select()", ID_LISTING );
			if( CheckMySocket( x ) == 1 )
				echo_server( x );				// Handle Client
			else
				accept_client();				// Accept new Connection
  }   }   }

void sockServerWnd::echo_server( int iClient )
  {
	int len;
	
	ShowStatus( hWndClass, "recv()", ID_LISTING );
	if(( len = RecvClient( iClient, (LPSTR)buffer, sizeof( buffer ))) <= 0 ) 
	  {	sprintf( szBuffer, "closesocket( %d ).", iClient );
		ShowStatus( hWndClass, szBuffer , ID_LISTING );
	  }
	else
	  {											// Client Socket Handle anzeigen
		sprintf( szBuffer, "  %4d ", iClient );
		ShowStatus( hWndClass, szBuffer, ID_SOCKET );

		buffer[len] = 0;						// Daten in Listbox ausgeben
		ShowStatus( hWndClass, buffer, ID_DATA );
	    ShowStatus( hWndClass, "send()", ID_LISTING );		
		SendClient( iClient, (LPSTR)buffer, len );
  }   }

void sockServerWnd::accept_client()
  {
	int    ns;
	struct sockaddr_in peer;
		
	ShowStatus( hWndClass, "accept()", ID_LISTING );
	if(( ns = Accept( &peer )) < 0 )
	  {	ShowStatus( hWndClass, "WARNING: Active connections: accept", ID_LISTING );
		return;
	  }
	
	remoteIP = inet_ntoa( peer.sin_addr );
	sprintf( szBuffer,"Open Connection from %s - Port %d (Handle %d)",
			 remoteIP, htons( peer.sin_port ), ns );
	ShowStatus( hWndClass, szBuffer, ID_LISTING );
  }


void sockServerWnd::ShowStatus( HWND hDlg, LPSTR lpMsg, int mWnd )
  {												// Status in Listbox protokollieren
	int iEntries;
												// Neuen Eintrag hinzufgen
	SendMessage( GetDlgItem( hDlg, mWnd ), 
				   LB_ADDSTRING, 
				   (WPARAM)-1, 
				   (LPARAM)lpMsg );              
  												// letzten Eintrag anzeigen
	iEntries = SendMessage( GetDlgItem( hDlg, mWnd ), 
			   LB_GETCOUNT,
			   0,                 
			   0 );
	SendMessage( GetDlgItem( hDlg, mWnd ), 
			   LB_SETTOPINDEX,
			   iEntries-1,           
			   0 ); 
  }

