/*******************************************************************************/
/* serv_udp.c										       (Win32 Application) */
/*                                                    Microsoft Visual C++ 5.0 */
/*******************************************************************************/
/* Beispielprogramm fr einen UDP-Server auf Port 7 (ECHO). Der Server akzep-  */
/* tiert mehrere Verbindungen und sendet das Echo der auf diesem Socket        */
/* empfangenen Daten an die Clients zurck, bis diese die Verbindung schlieen.*/
/*******************************************************************************/

#include <winsock.h>							// #windows.h
#include <stdio.h>
#include "resource.h"

#define	ECHO_PORT	7
#define	BUFFER_SIZE	512							// maximal COM-Server Buffer


long	FAR PASCAL WTcpServProc( HWND, unsigned, WORD, LONG );
void	ShowStatus( HWND, LPSTR, int );
void    read_and_echo( HWND, SOCKET );
int		WINAPI  WinMain( HANDLE, HANDLE, LPSTR, int );

char    buffer[ BUFFER_SIZE ];
struct	timeval  seltime;
fd_set  readfds;

char    szBuffer[ 256 ];						// used for messages
char FAR* remoteIP;
	


VOID wtcp_serv( HWND hWnd )
  {
	SOCKET MySocket;
	struct sockaddr_in addr;
	MSG	   msg;
												// open Socket, Protocol UDP
	ShowStatus( hWnd, "socket()", ID_LISTING );
	if(( MySocket = socket( AF_INET, SOCK_DGRAM, 0 )) < 0 ) 
	  {	ShowStatus( hWnd, " failed.", ID_LISTING );
		return;
	  }
	
	addr.sin_family = AF_INET;
	addr.sin_port = htons( ECHO_PORT );
	addr.sin_addr.s_addr = 0;
												// bind Socket to addr
	ShowStatus( hWnd, "bind()", ID_LISTING );
	if( bind( MySocket, ( const struct sockaddr FAR *)&addr, sizeof( addr )) < 0 )
	  {	( void )closesocket( MySocket );
		ShowStatus(hWnd, " failed.", ID_LISTING);
		return;
	  }
	
	EnableWindow( GetDlgItem( hWnd, ID_SERVER ), FALSE );
		
	for (;;) 
	  {	FD_ZERO( (fd_set FAR *)&readfds );
		FD_SET( MySocket, (fd_set FAR *)&readfds );
		seltime.tv_sec = 0;
		seltime.tv_usec = 100;

		if( !select( 0,
					(fd_set FAR *)&readfds, (fd_set FAR *) 0, (fd_set FAR *) 0,
					(const struct timeval FAR *)&seltime )) 
		  {	
												// read Message from PostQuitMessage()
			if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE )) 
			  {	if( msg.message == WM_QUIT ) 
				  {	( void )closesocket( MySocket );
			    	return;
				  }
			    TranslateMessage( &msg );
			    DispatchMessage( &msg );
			  }
			continue;
		  }
												// check socket for readability 



		if( FD_ISSET( MySocket, (fd_set FAR *)&readfds ))
		  {	ShowStatus( hWnd, "select()", ID_LISTING );
			read_and_echo(hWnd, MySocket);
  }	  }	  }




void read_and_echo( HWND hWnd, SOCKET MySocket ) // read and echo data	
  {
	int	   iLen;
	struct sockaddr_in peer;
	int	   peersize = sizeof(peer);
	long   blocking;

	blocking = 0;

	
	ioctlsocket( MySocket, FIONBIO, (u_long FAR *)blocking);
	
	ShowStatus( hWnd, "recvfrom()", ID_LISTING );
	if(( iLen = recvfrom( MySocket, ( LPSTR )buffer, sizeof( buffer ), 0,
					   ( struct sockaddr FAR* )&peer, &peersize )) <= 0 )
	  {	ShowStatus( hWnd, " failed.", ID_LISTING );
		( void )closesocket( MySocket );
		ShowStatus( hWnd, "closesocket()", ID_LISTING );
		EnableWindow( GetDlgItem( hWnd, ID_SERVER ), TRUE );
	  }
	else
	  {	
		remoteIP = inet_ntoa( peer.sin_addr );	// IP-Address -> Dot-Notation
		sprintf( szBuffer, "%s - %d          %d", 
				remoteIP, htons( peer.sin_port ), iLen );
		ShowStatus( hWnd, szBuffer, ID_SOCKET );
		
		buffer[iLen] = 0;
		ShowStatus( hWnd, buffer, ID_DATA );

		if( sendto( MySocket, (LPSTR) buffer, iLen, 0, 
				  ( const struct sockaddr FAR*)&peer, peersize) < 0 )
			closesocket( MySocket );
		else
			ShowStatus( hWnd, "sendto()", ID_LISTING );
	  }
  }


long WINAPI WTcpServProc(
	HWND            hWnd,
	unsigned        message,
	WORD            wParam,
	LONG            lParam )

  {
	switch( message ) 
	  { 
		case WM_COMMAND:						// Schaltflchen-Kommandos
			switch( wParam ) 
			  {	
				case ID_SERVER:					// Schaltflche Start Server
					wtcp_serv( hWnd );
				break;
				case ID_EXIT:					// Schaltflche Exit
				case IDCANCEL:					// Schaltflche Fenster schlieen
					DestroyWindow( hWnd );
				break;
			  }
		break;
		
		case WM_DESTROY:						// Fenster geschlossen
			PostQuitMessage( 0 );				// sende WM_QUIT zur Application
			break;
		
		default:
		break;
	  }
	return( 0 );
  }




void ShowStatus( HWND hDlg, LPSTR lpMsg, int mWnd )// Status in Listbox protokollieren
  {
	int iEntries;
												// Neuen Eintrag hinzufgen
	SendMessage( GetDlgItem( hDlg, mWnd ), 
							LB_ADDSTRING, 
							(WPARAM)-1, 
							(LPARAM)lpMsg ); 
  												// letzten Eintrag anzeigen
	iEntries = SendMessage( GetDlgItem( hDlg, mWnd ), 
										LB_GETCOUNT,
										0,                 
										0 );
	SendMessage( GetDlgItem( hDlg, mWnd ), 
							 LB_SETTOPINDEX,
							 iEntries-1,           
							 0 ); 
  }


int WINAPI WinMain(		
	HINSTANCE	hInstance,
	HINSTANCE	hPrevInstance,
	LPSTR		lpCmdLine,
	int			nShowCmd )
  {		
	WSADATA		wsadata;
												// init Winsock-DLL Version 1.1
	if( WSAStartup( MAKEWORD( 1,1 ), &wsadata ) == 0 )
	  {	DialogBox( hInstance, MAKEINTRESOURCE( IDD_WSSERVER ),
				   NULL, WTcpServProc );
		WSACleanup();
	  }
	else
		MessageBox( 0, "Fehler beim Initialisieren der WINSOCK.DLL",
					   "WSClient.EXE", 0 );
	return( 0 );
  }
