unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, WSocket, ComCtrls, ScktComp;

type
  TForm1 = class(TForm)
    bt_connect: TButton;
    bt_sendbininfo: TButton;
    ed_httplogin: TEdit;
    ed_dummy: TEdit;
    ed_maintype: TEdit;
    ed_subtype: TEdit;
    ed_srcport: TEdit;
    ed_destport: TEdit;
    ed_srcip: TEdit;
    ed_httplogin_: TEdit;
    ed_destport_: TEdit;
    ed_srcport_: TEdit;
    ed_srcip_: TEdit;
    ed_subtype_: TEdit;
    ed_maintype_: TEdit;
    ed_dummy_: TEdit;
    bt_disconnect: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    ed_webio_ip: TEdit;
    ed_passwort_: TEdit;
    Label11: TLabel;
    ClientSocket1: TClientSocket;
    StatusBar1: TStatusBar;
    procedure bt_connectClick(Sender: TObject);
    procedure bt_sendbininfoClick(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

type RBinInfo= packed record
       dummy : word;
       maintype : byte;
       subtype : byte;
       srcip : longword;
       srcport : word;
       destport : word;
end;

type
  CharArray8 = array[0..7] of char;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//** start connecting
procedure TForm1.bt_connectClick(Sender: TObject);
begin
  ClientSocket1.Address := ed_webio_ip.Text;
  ClientSocket1.Port := 80;
  ClientSocket1.Active := True;
end;

//** Procedure runs if connetion take place
procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  bt_connect.Enabled := false;
  bt_disconnect.Enabled := True;
  bt_sendbininfo.Enabled := True;
  ed_httplogin.Text := '';
  ed_dummy.Text := '';
  ed_maintype.Text := '';
  ed_subtype.Text := '';
  ed_srcip.Text := '';
  ed_srcport.Text := '';
  ed_destport.Text := '';
  Statusbar1.SimpleText := 'connected';
end;

//** send BinInfo Structure
procedure TForm1.bt_sendbininfoClick(Sender: TObject);
var dummycount : integer;
    dummystring : string;
    dummystring2 : string;
    tabpos : array [1..3] of integer;
    PBininfo : ^RBinInfo;
    httplogin : String[59];  //buffer for send out
begin
  //**copy stringpart to buffer for send out
  httplogin := ed_httplogin_.text + ed_passwort_.text + '&' + chr(0);
  //**set pointer of structure to first Byte behind string part
  PBininfo := @httplogin[length(ed_httplogin_.text) + length(ed_passwort_.text)+3];
  //** copy input lines to strukure fields
  PBininfo^.dummy := strtoint(ed_dummy_.Text);
  PBininfo^.maintype := strtoint(ed_maintype_.Text);
  PBininfo^.subtype := strtoint(ed_subtype_.Text);
  //**convert IP String to longword field of the structure
  if ed_srcip_.text = '' then
    showMessage('Please enter your own IP address in srcip field')
  else
  begin
    dummystring2 :=  ed_srcip_.text;
    for dummycount := 1 to 3 do
    begin
      tabpos[dummycount] := pos( '.',dummystring2);
      dummystring2[tabpos[dummycount]] := ' ';
    end;
    dummystring := copy (dummystring2, 1, tabpos[1] - 1);
    PBininfo^.srcip := strtoint (dummystring) * $1000000;
    dummystring := copy (dummystring2, tabpos[1] + 1 , (tabpos[2] - 1)-( tabpos[1] ));
    PBininfo^.srcip := PBininfo^.srcip + strtoint (dummystring) * $10000;
    dummystring := copy (dummystring2, tabpos[2] + 1 , (tabpos[3] - 1)-( tabpos[2] ));
    PBininfo^.srcip := PBininfo^.srcip + strtoint (dummystring) * $100;
    dummystring := copy (dummystring2, tabpos[3] + 1 , length(dummystring2)-( tabpos[3] ));
    PBininfo^.srcip := PBininfo^.srcip + strtoint (dummystring);
    //** copy input lines to strukure fields
    PBininfo^.srcport := strtoint(ed_srcport_.Text);
    PBininfo^.destport := strtoint(ed_destport_.Text);
    //** set stringlength to length of string part plus sturcture length
    SetLength(httplogin, length(ed_httplogin_.text) + length(ed_passwort_.text) + 14);
    // send string out
    Clientsocket1.Socket.SendText(httplogin);
  end;  
end;

//** this procedure parse the incomming datas
procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);
var inbuffer : array [0..19] of Byte;
    PBinInfo : ^RBinInfo;
    phttplogin : ^CharArray8;
begin
  Clientsocket1.Socket.ReceiveBuf(inbuffer, Clientsocket1.Socket.ReceiveLength);
  //**set Pointer of bininfo structure to first byte behind string part
  PBininfo := @inbuffer[8];
  phttplogin := @inbuffer;
  //**fill input lines
  ed_httplogin.Text := phttplogin^;
  ed_dummy.Text := inttostr(PBininfo^.dummy);
  ed_maintype.Text := inttostr(PBininfo^.maintype);
  ed_subtype.Text := inttostr(PBininfo^.subtype);
  //** converting lonword to IP address string
  ed_srcip.Text := inttostr(PBininfo^.srcip and $ff000000 div $ffffff) + '.'
                   + inttostr(PBininfo^.srcip and $00ff0000 div $ffff) + '.'
                   + inttostr(PBininfo^.srcip and $0000ff00 div $ff) + '.'
                   + inttostr(PBininfo^.srcip and $000000ff);
  //**fill input lines
  ed_srcport.Text := inttostr(PBininfo^.srcport);
  ed_destport.Text := inttostr(PBininfo^.destport);
  //** show message for user
  If PBininfo^.maintype = 2 Then
  begin
    case PBininfo^.subtype of
      1 : showMessage('Web-IO is ready for binary access');
      4 : showMessage('Web-IO is ready for binary access in a few seconds');
    Else
      showMessage('Web-IO - access denied');
    end;
  end
  Else
    showMessage('Web-IO - access denied');
end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  bt_connect.Enabled := true;
  bt_disconnect.Enabled := false;
  bt_sendbininfo.Enabled := false;
  clientsocket1.Active := false;
  Statusbar1.SimpleText := 'disconnected';  
end;

end.
