////////////////////////////////////////////////////////////////////////////////////////////////
// Web_IO_ClientDlg.cpp : Implementation File
////////////////////////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "Web_IO_Client.h"
#include "Web_IO_ClientDlg.h"
#include "MySocket.h"
#include <cstdio>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

////////////////////////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfield for "Info"
////////////////////////////////////////////////////////////////////////////////////////////////

MySocket m_clientSocket;

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialogfield Data 
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Overloead virtual Methods, generated by class assistent
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Backup
	//}}AFX_VIRTUAL

	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

////////////////////////////////////////////////////////////////////////////////////////////////
// CWeb_IO_ClientDlg Dialogfeld
// Definition of Buttons-, Textfield-, CheckBox-Elements and theirs variables
////////////////////////////////////////////////////////////////////////////////////////////////

CWeb_IO_ClientDlg::CWeb_IO_ClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWeb_IO_ClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWeb_IO_ClientDlg)
	//}}AFX_DATA_INIT
	// The LoadIcon under Win32 required no more DestroyIcon-Call
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWeb_IO_ClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWeb_IO_ClientDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWeb_IO_ClientDlg, CDialog)
	//{{AFX_MSG_MAP(CWeb_IO_ClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OUTPUT0, OnOutput0)
	ON_BN_CLICKED(IDC_OUTPUT1, OnOutput1)
	ON_BN_CLICKED(IDC_POLLING0, OnPolling0)
	ON_BN_CLICKED(IDC_POLLING1, OnPolling1)
	ON_BN_CLICKED(IDC_POLLINGCOUNTER, OnPollingcounter)
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_POLLINGTEXT, OnChangePollingtext)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

////////////////////////////////////////////////////////////////////////////////////////////////
// CWeb_IO_ClientDlg Message-Handler
////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CWeb_IO_ClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// IDM_ABOUTBOX must be located at the system-instructions
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Defintion of symbol for dialogfeld. Automatic completed if
	// mainwindow of the application is no dialogfield.
	SetIcon(m_hIcon, TRUE);			// Use big symbol
	SetIcon(m_hIcon, FALSE);		// Use small symbol

	changeAccess(FALSE);
	SendMessage(DM_SETDEFID, IDC_CONNECT);

	// Statusbar element to display messages on the application
    m_statusBar = new CStatusBarCtrl;
    m_statusBar->Create(WS_CHILD|WS_VISIBLE, CRect(0, 0, 0, 0), this, 0);

	// Private variables for the connection, the polling or the password
	SetDlgItemText(IDC_IPTEXT, "");	
	SetDlgItemText(IDC_PORTTEXT, "80");
	SetDlgItemText(IDC_PASSWORDTEXT, "");
	SetDlgItemText(IDC_POLLINGTEXT, "1000");
	m_statusBar->SetText("Disconnected!", 0, 0);

	// To Receive from the Web-IO give the socket this applikation
	m_clientSocket.m_client = this;
	SendMessage(DM_SETDEFID, IDC_CONNECT);

	// Return false if you wish one element to get the focus
	return TRUE;
}

void CWeb_IO_ClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

	// To minimize the window of the application the following method is important.
	// If your MFC-application use the document/view-model, the minimize function
	// will be automatic completed 

void CWeb_IO_ClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		// Devicecontext to draw
		CPaintDC dc(this); 

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center symbol in client-rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw symbol
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CWeb_IO_ClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
	// To change the accessibility of elements on the graphical user interface
void CWeb_IO_ClientDlg::changeAccess(bool b)
{
	if(b == TRUE)
	{
		// All now important elements of the application get available and the
		// connect-button get inaccessible
		GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);
		GetDlgItem(IDC_DISCONNECT)->EnableWindow(TRUE);
		GetDlgItem(IDC_OUTPUT0)->EnableWindow(TRUE);
		GetDlgItem(IDC_OUTPUT1)->EnableWindow(TRUE);
		GetDlgItem(IDC_READALL0)->EnableWindow(TRUE);
		GetDlgItem(IDC_READALL1)->EnableWindow(TRUE);
		GetDlgItem(IDC_POLLING0)->EnableWindow(TRUE);
		GetDlgItem(IDC_POLLING1)->EnableWindow(TRUE);
		GetDlgItem(IDC_POLLINGTEXT)->EnableWindow(TRUE);
		GetDlgItem(IDC_POLLINGCOUNTER)->EnableWindow(TRUE);
		GetDlgItem(IDC_READ0)->EnableWindow(TRUE);
		GetDlgItem(IDC_READ1)->EnableWindow(TRUE);
		GetDlgItem(IDC_CLEAR0)->EnableWindow(TRUE);
		GetDlgItem(IDC_CLEAR1)->EnableWindow(TRUE);
		GetDlgItem(IDC_READALL)->EnableWindow(TRUE);
		GetDlgItem(IDC_CLEARALL)->EnableWindow(TRUE);
	}
	else
	{
		// Connect-button get accessible, all other Elements get inaccessible.
		// This is the state at the beginning of the application
		GetDlgItem(IDC_CONNECT)->EnableWindow(TRUE);
		GetDlgItem(IDC_DISCONNECT)->EnableWindow(FALSE);
		GetDlgItem(IDC_OUTPUT0)->EnableWindow(FALSE);
		GetDlgItem(IDC_OUTPUT1)->EnableWindow(FALSE);
		GetDlgItem(IDC_INPUT0)->EnableWindow(FALSE);
		GetDlgItem(IDC_INPUT1)->EnableWindow(FALSE);
		GetDlgItem(IDC_READALL0)->EnableWindow(FALSE);
		GetDlgItem(IDC_READALL1)->EnableWindow(FALSE);
		GetDlgItem(IDC_POLLING0)->EnableWindow(FALSE);
		GetDlgItem(IDC_POLLING1)->EnableWindow(FALSE);
		GetDlgItem(IDC_POLLINGTEXT)->EnableWindow(FALSE);
		GetDlgItem(IDC_POLLINGCOUNTER)->EnableWindow(FALSE);
		GetDlgItem(IDC_COUNTERTEXT0)->EnableWindow(FALSE);
		GetDlgItem(IDC_COUNTERTEXT1)->EnableWindow(FALSE);
		GetDlgItem(IDC_READ0)->EnableWindow(FALSE);
		GetDlgItem(IDC_READ1)->EnableWindow(FALSE);
		GetDlgItem(IDC_CLEAR0)->EnableWindow(FALSE);
		GetDlgItem(IDC_CLEAR1)->EnableWindow(FALSE);
		GetDlgItem(IDC_READALL)->EnableWindow(FALSE);
		GetDlgItem(IDC_CLEARALL)->EnableWindow(FALSE);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////
// The following method creates an connection to the Web-IO 
////////////////////////////////////////////////////////////////////////////////////////////////
	// Try to connect to host
void CWeb_IO_ClientDlg::TryConnect()
{// If a negativ port has been entered
	if(m_port < 0)
	{
		m_statusBar->SetText("No negativ port allowed!", 0, 0);
		return;
	}
	// Create the socket for the connection 
	m_clientSocket.Create();
	m_clientSocket.Connect(m_ip, m_port);
	GetDlgItem(IDC_CONNECT)->EnableWindow(FALSE);
}
	// Connection done
void CWeb_IO_ClientDlg::OnConnect()
{
	// In case of success display another message
	m_statusBar->SetText("Connected!", 0, 0);
	changeAccess(TRUE);
}
	// Close the connection
void CWeb_IO_ClientDlg::OnDisconnect()
{
	m_clientSocket.Close();
	m_statusBar->SetText("Disconnected!", 0, 0);
	changeAccess(FALSE);
}
	// If a password is set, update this to the variable
void CWeb_IO_ClientDlg::checkpass()
{
	GetDlgItemText(IDC_PASSWORDTEXT, m_password);
}
	// The receive-method of the application will be called if a message 
	// get send form the Web-IO
void CWeb_IO_ClientDlg::OnReceive()
{
	// Read the first 50 characters out of the stream
	m_clientSocket.Receive(m_rcv.GetBuffer(50),50);
	// and release it into an CString
	m_rcv.ReleaseBuffer();
	// If the Web-IO close the connection disconnect the application
	if(m_rcv.IsEmpty())
		OnDisconnect();
	// Is the received string longer than 1 char, so is a message received
	else if(m_rcv.GetLength() > 1)
	{
		// Check if the first char of m_rcv is an 'o', so its handle about an output
		if(m_rcv[0] == 'o')
		{
			// Read the hex value and covert it into an integer
			int i;
			sscanf(m_rcv.Right(m_rcv.GetLength() - 7), "%x", &i);
			// Set the specific output switched by the received state
			if((i & 1) == 1)	CheckDlgButton(IDC_OUTPUT0, BST_CHECKED);
			else				CheckDlgButton(IDC_OUTPUT0, BST_UNCHECKED);
			if((i & 2) == 2)	CheckDlgButton(IDC_OUTPUT1, BST_CHECKED);
			else				CheckDlgButton(IDC_OUTPUT1, BST_UNCHECKED);
		}
		// If the first entry of the CString is an 'i', so the inputs get the focus
		if(m_rcv[0] == 'i')
		{	
			// Read the hex value and convert it into an integer
			int i;
			sscanf(m_rcv.Right(m_rcv.GetLength() - 6), "%x", &i);
			// Set the specific input switched by the received state
			if((i & 1) == 1)	CheckDlgButton(IDC_INPUT0, BST_CHECKED);
			else				CheckDlgButton(IDC_INPUT0, BST_UNCHECKED);
			if((i & 2) == 2)	CheckDlgButton(IDC_INPUT1, BST_CHECKED);
			else				CheckDlgButton(IDC_INPUT1, BST_UNCHECKED);
		}
		// The last case handle about the counterstate
		if(m_rcv[0] == 'c')
		{	
			// If its directly a counter, update his text
			if(m_rcv[7] == '0')	SetDlgItemText(IDC_COUNTERTEXT0, m_rcv.Right(m_rcv.GetLength() - 9));
			if(m_rcv[7] == '1')	SetDlgItemText(IDC_COUNTERTEXT1, m_rcv.Right(m_rcv.GetLength() - 9));
			// Else call the method to read and clear all counter states
			if(m_rcv[7] == ';')	readAndClearCounter(m_rcv.Right(m_rcv.GetLength() - 8));
		}
	}
}

void CWeb_IO_ClientDlg::OnSend()
{

}

void CWeb_IO_ClientDlg::OnClose()
{
	OnDisconnect();
}

	// Here get ctached all fired events of the timer
void CWeb_IO_ClientDlg::OnTimer(UINT nIDEvent)
{
	// In case of the timer, the specific event will be called
	if(nIDEvent == 1) OnClickReadall0();
	if(nIDEvent == 2) OnClickReadall1();
	if(nIDEvent == 3) OnClickReadall();
	CDialog::OnTimer(nIDEvent);
}
	// This method read an set all counter states
void CWeb_IO_ClientDlg::readAndClearCounter(CString data)
{
	// Create a field of strings, each counter one string
	int j = 0;
	CString counter[12];
	// For the length of the string with all counter states
	for(int i = 0; i < data.GetLength(); i++)
	{	// Each counter state in the string end with ';', so after this char
		// begin the entry in a new string for another counter
		if(data[i] == ';')
			j++;
		// Because one counter can include more then one char in the string
		// append them all on the specific string
		else
			counter[j] += data[i];
	}
	// Set the textfields of the counter with the new state
	SetDlgItemText(IDC_COUNTERTEXT0, counter[0]);
	SetDlgItemText(IDC_COUNTERTEXT1, counter[1]);
}

///////////////////////////////////////////////////////////////////////////////////////////////
// Button- , checkboxen- , textfield - allocation
///////////////////////////////////////////////////////////////////////////////////////////////

BEGIN_EVENTSINK_MAP(CWeb_IO_ClientDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CWeb_IO_ClientDlg)
	ON_EVENT(CWeb_IO_ClientDlg, IDC_CONNECT, -600 /* Click */, OnClickConnect, VTS_NONE)
	ON_EVENT(CWeb_IO_ClientDlg, IDC_DISCONNECT, -600 /* Click */, OnClickDisconnect, VTS_NONE)
	ON_EVENT(CWeb_IO_ClientDlg, IDC_READALL0, -600 /* Click */, OnClickReadall0, VTS_NONE)
	ON_EVENT(CWeb_IO_ClientDlg, IDC_READALL1, -600 /* Click */, OnClickReadall1, VTS_NONE)
	ON_EVENT(CWeb_IO_ClientDlg, IDC_READ0, -600 /* Click */, OnClickRead0, VTS_NONE)
	ON_EVENT(CWeb_IO_ClientDlg, IDC_READ1, -600 /* Click */, OnClickRead1, VTS_NONE)
	ON_EVENT(CWeb_IO_ClientDlg, IDC_READALL, -600 /* Click */, OnClickReadall, VTS_NONE)
	ON_EVENT(CWeb_IO_ClientDlg, IDC_CLEAR0, -600 /* Click */, OnClickClear0, VTS_NONE)
	ON_EVENT(CWeb_IO_ClientDlg, IDC_CLEAR1, -600 /* Click */, OnClickClear1, VTS_NONE)
	ON_EVENT(CWeb_IO_ClientDlg, IDC_CLEARALL, -600 /* Click */, OnClickClearall, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()
	// The connect button call by click this method
void CWeb_IO_ClientDlg::OnClickConnect() 
{
	// Read the IP-address and the port typed in the application
	GetDlgItemText(IDC_IPTEXT, m_ip);
	GetDlgItemText(IDC_PORTTEXT, m_message2);
	sscanf(m_message2, "%d", &m_port);
	if(m_ip == "")	{ m_statusBar->SetText("No IP entered!", 0, 0); }
	else if(m_port == 0){ m_statusBar->SetText("No port entered!", 0, 0); }
	// If IP and port entered, try to cennect to the Web-IO
	else				{ TryConnect(); }
}
	// By click on the diconnect button display an message and close the socket
void CWeb_IO_ClientDlg::OnClickDisconnect() 
{
	OnDisconnect();
}
	// Set or unset the output number 0
void CWeb_IO_ClientDlg::OnOutput0() 
{
	// Check if a password has been entered
	checkpass();
	m_message1 = "GET /outputaccess0?PW=" + m_password + "&State=ON&";
	m_message2 = "GET /outputaccess0?PW=" + m_password + "&State=OFF&";
	// If checkbox of output number 0 get checked or unchecked
	if(IsDlgButtonChecked(IDC_OUTPUT0))	m_clientSocket.Send(m_message1, m_message1.GetLength()); 	
	else								m_clientSocket.Send(m_message2, m_message2.GetLength());				
}
	// Set or unset output number 1
void CWeb_IO_ClientDlg::OnOutput1() 
{
	checkpass();
	m_message1 = "GET /outputaccess1?PW=" + m_password + "&State=ON&";
	m_message2 = "GET /outputaccess1?PW=" + m_password + "&State=OFF&";
	if(IsDlgButtonChecked(IDC_OUTPUT1))	m_clientSocket.Send(m_message1, m_message1.GetLength());
	else								m_clientSocket.Send(m_message2, m_message2.GetLength());
}
	// Read all outputs on the Web-IO
void CWeb_IO_ClientDlg::OnClickReadall0() 
{
	checkpass();
	m_message1 = "GET /output?PW=" + m_password + "&";
	m_clientSocket.Send(m_message1, m_message1.GetLength());
}
	// Read all inputs on the Web-IO
void CWeb_IO_ClientDlg::OnClickReadall1() 
{
	checkpass();
	m_message1 = "GET /input?PW=" + m_password + "&";
	m_clientSocket.Send(m_message1, m_message1.GetLength());
}
	// To check cyclic the state of the outputs use this method 
void CWeb_IO_ClientDlg::OnPolling0() 
{
	if(IsDlgButtonChecked(IDC_POLLING0))
		// Initialization and destruction of a timer with the specific range
		SetTimer(1, m_range, NULL);
	else
		KillTimer(1);
}
	// Check the state of the inputs by polling
void CWeb_IO_ClientDlg::OnPolling1() 
{
	if(IsDlgButtonChecked(IDC_POLLING1))
		SetTimer(2, m_range, NULL);
	else
		KillTimer(2);
}

	// Send a request to check the state of the counter number 0
void CWeb_IO_ClientDlg::OnClickRead0() 
{
	checkpass();
	m_message1 = "GET /counter0?PW=" + m_password + "&";
	m_clientSocket.Send(m_message1, m_message1.GetLength());
}
	// Check the state of counter number 1
void CWeb_IO_ClientDlg::OnClickRead1() 
{
	checkpass();
	m_message1 = "GET /counter1?PW=" + m_password + "&";
	m_clientSocket.Send(m_message1, m_message1.GetLength());
}
	// In this method all counter states can be read
void CWeb_IO_ClientDlg::OnClickReadall() 
{
	checkpass();
	m_message1 = "GET /counter?PW=" + m_password + "&";
	m_clientSocket.Send(m_message1, m_message1.GetLength());
}
	// Clear counter 0, set his state to zero
void CWeb_IO_ClientDlg::OnClickClear0() 
{
	checkpass();
	m_message1 = "GET /counterclear0?PW=" + m_password + "&";
	m_clientSocket.Send(m_message1, m_message1.GetLength());
}
	// Clear counter 1
void CWeb_IO_ClientDlg::OnClickClear1() 
{
	checkpass();
	m_message1 = "GET /counterclear1?PW=" + m_password + "&";
	m_clientSocket.Send(m_message1, m_message1.GetLength());
}
	// Clear all counter
void CWeb_IO_ClientDlg::OnClickClearall() 
{
	checkpass();
	m_message1 = "GET /counterclear?PW=" + m_password + "&";
	m_clientSocket.Send(m_message1, m_message1.GetLength());
}
	// By polling the counter, all state changes can be automatic updated
void CWeb_IO_ClientDlg::OnPollingcounter() 
{
	if(IsDlgButtonChecked(IDC_POLLINGCOUNTER))
		SetTimer(3, m_range, NULL);
	else
		KillTimer(3);
}
	// The user can update the range for polling by changing the value of
	// IDC_POLLINGTEXT
void CWeb_IO_ClientDlg::OnChangePollingtext() 
{
	// Update the variable range
	GetDlgItemText(IDC_POLLINGTEXT, m_message2);
	int check;
	sscanf(m_message2, "%d", &check);
	if(check <= 0)
	{
		m_statusBar->SetText("No negativ value or character allowed!", 0, 0);
		return;
	}
	m_range = check;
	m_statusBar->SetText("Range changed!", 0, 0);
	// The new range for the polling must updated to the IDC_POLLINGTEXT field 
}
