Imports System.Net.Sockets
Imports System.Net
'Imports System.IO

Public Class Form1
    Public Structure IO_State
        Dim outputstate0 As Boolean
        Dim outputstate1 As Boolean
        Dim inputstate0 As Boolean
        Dim inputstate1 As Boolean
        Dim countervalue0 As Long
        Dim countervalue1 As Long
    End Structure

    Private Delegate Sub DelegateSub()
    Private connectenable As New DelegateSub(AddressOf connect_enable)
    Private disconnectenable As New DelegateSub(AddressOf disconnect_enable)
    Private formupdate As New DelegateSub(AddressOf form_update)
    Dim TCP_client As Socket
    Dim connection_ar As IAsyncResult
    Dim receivebuffer(511) As Byte
    Dim IOState As IO_State

    Private Sub connect_enable()
        bt_connect.Enabled = False
        gb_io.Enabled = True
        bt_disconnect.Enabled = True
        Timer_polling.Enabled = True
        ToolStripStatusLabel1.Text = "Connected to " + tb_ip.Text + " : " + tb_port.Text
    End Sub

    Private Sub disconnect_enable()
        bt_connect.Enabled = True
        gb_io.Enabled = False
        bt_disconnect.Enabled = False
        Timer_polling.Enabled = False
        ToolStripStatusLabel1.Text = "No Connection"
    End Sub

    Private Sub form_update()
        If IOState.inputstate0 = True Then
            cb_input0.Checked = True
        Else
            cb_input0.Checked = False
        End If
        If IOState.inputstate1 = True Then
            cb_input1.Checked = True
        Else
            cb_input1.Checked = False
        End If
        If IOState.outputstate0 = True Then
            cb_output0.Checked = True
        Else
            cb_output0.Checked = False
        End If
        If IOState.outputstate1 = True Then
            cb_Output1.Checked = True
        Else
            cb_Output1.Checked = False
        End If
        tb_counter0.Text = IOState.countervalue0
        tb_counter1.Text = IOState.countervalue1
    End Sub

    Private Sub bt_connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_connect.Click
        Dim WebIOep As New IPEndPoint(IPAddress.Parse(tb_ip.Text), Val(tb_port.Text))
        If tb_ip.Text <> "" And tb_port.Text <> "" Then
            TCP_client = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
            bt_connect.Enabled = False
            Try
                TCP_client.BeginConnect(WebIOep, New AsyncCallback(AddressOf callback_connect), _
      TCP_client)
            Catch ex As Exception
            End Try
        End If
    End Sub

    Private Sub callback_connect(ByVal ar As IAsyncResult)
        Invoke(connectenable)
        connection_ar = ar
        Try
            TCP_client.EndConnect(ar)
            TCP_client.BeginReceive(receivebuffer, 0, 512, SocketFlags.None, New AsyncCallback(AddressOf callback_readdata), TCP_client)
        Catch ex As Exception
            closeconnections()
        End Try
    End Sub

    Private Sub callback_readdata(ByVal ar As IAsyncResult)
        If TCP_client.Connected Then
            Dim bytesread As Integer
            Try
                bytesread = TCP_client.EndReceive(ar)
            Catch ex As Exception
            End Try
            If bytesread = 0 Then
                closeconnections()
            Else
                Dim receivestring As String
                receivestring = System.Text.Encoding.ASCII.GetString(receivebuffer, 0, _
                receivebuffer.Length)
                Array.Clear(receivebuffer, 0, 512)
                Try
                    TCP_client.BeginReceive(receivebuffer, 0, 512, SocketFlags.None, New AsyncCallback(AddressOf callback_readdata), TCP_client)
                Catch ex As Exception
                    closeconnections()
                End Try
                Select Case Mid(receivestring, 1, 1)
                    Case "i"
                        If (Val(Mid(receivestring, 7, 1)) And 1) = 1 Then
                            IOState.inputstate0 = True
                        Else
                            IOState.inputstate0 = False
                        End If
                        If (Val(Mid(receivestring, 7, 1)) And 2) = 2 Then
                            IOState.inputstate1 = True
                        Else
                            IOState.inputstate1 = False
                        End If
                    Case "o"
                        If (Val(Mid(receivestring, 8, 1)) And 1) = 1 Then
                            IOState.outputstate0 = True
                        Else
                            IOState.outputstate0 = False
                        End If
                        If (Val(Mid(receivestring, 8, 1)) And 2) = 2 Then
                            IOState.outputstate1 = True
                        Else
                            IOState.outputstate1 = False
                        End If
                    Case "c"
                        Dim tabpos
                        If Mid(receivestring, 8, 1) = "0" Then _
                          IOState.countervalue0 = Mid(receivestring, 10)
                        If Mid(receivestring, 8, 1) = "1" Then _
                          IOState.countervalue1 = Mid(receivestring, 10)
                        If Mid(receivestring, 8, 1) = ";" Then
                            tabpos = InStr(9, receivestring, ";")
                            IOState.countervalue0 = Val(Mid(receivestring, 9, tabpos - 9))
                            IOState.countervalue1 = Val(Mid(receivestring, tabpos + 1, _
                            Len(receivestring) - tabpos - 1))
                        End If
                End Select
                Invoke(formupdate)
            End If
        End If
    End Sub

    Private Sub sendcommand(ByVal sendstring As String)
        Dim senddata As Byte() = System.Text.Encoding.ASCII.GetBytes(sendstring)
        Try
            TCP_client.Send(senddata)
        Catch ex As Exception
            closeconnections()
        End Try
    End Sub

    Private Sub closeconnections()
        Try
            TCP_client.EndReceive(connection_ar)
        Catch ex As Exception
        End Try
        Try
            TCP_client.Shutdown(SocketShutdown.Both)
        Catch ex As Exception
        End Try
        Try
            TCP_client.Close()
        Catch ex As Exception
        End Try
        Invoke(disconnectenable)
    End Sub

    Private Sub cb_output0_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles cb_output0.MouseUp
        If cb_output0.Checked Then
            sendcommand("GET /outputaccess0?PW=" + tb_password.Text + "&State=ON&")
        Else
            sendcommand("GET /outputaccess0?PW=" + tb_password.Text + "&State=OFF&")
        End If
    End Sub

    Private Sub cb_Output1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles cb_Output1.MouseUp
        If cb_Output1.Checked Then
            sendcommand("GET /outputaccess1?PW=" + tb_password.Text + "&State=ON&")
        Else
            sendcommand("GET /outputaccess1?PW=" + tb_password.Text + "&State=OFF&")
        End If
    End Sub

    Private Sub bt_outputs_read_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_outputs_read.Click
        sendcommand("GET /output?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub bt_inputs_read_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_inputs_read.Click
        sendcommand("GET /input?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub bt_counter_read0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_read0.Click
        sendcommand("GET /counter0?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub bt_counter_read1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_read1.Click
        sendcommand("GET /counter1?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub bt_counter_readall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_readall.Click
        sendcommand("GET /counter?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub bt_counter_clear0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_clear0.Click
        sendcommand("GET /counterclear0?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub bt_counter_clear1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_clear1.Click
        sendcommand("GET /counterclear1?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub bt_counter_clearall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_counter_clearall.Click
        sendcommand("GET /counterclear?PW=" + tb_password.Text + "&")
    End Sub

    Private Sub Timer_polling_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer_polling.Tick
        If (cb_input_polling.Checked And TCP_client.Connected) Then
            sendcommand("GET /input?PW=" + tb_password.Text + "&")
        End If
        If (cb_output_polling.Checked And TCP_client.Connected) Then
            sendcommand("GET /output?PW=" + tb_password.Text + "&")
        End If
        If (cb_counter_polling.Checked And TCP_client.Connected) Then
            sendcommand("GET /counter?PW=" + tb_password.Text + "&")
        End If
    End Sub

    Private Sub tb_interval_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tb_interval.TextChanged
        Timer_polling.Interval = Val(tb_interval.Text)
    End Sub

    Private Sub bt_disconnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bt_disconnect.Click
        Invoke(disconnectenable)
        closeconnections()
    End Sub
End Class
