// AmpelDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Ampel.h"
#include "AmpelDlg.h"
#include "MySocket.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



// Konstanten fr die Farben als RGB Werte
const RED_OFF=RGB(64,0,0);
const YELLOW_OFF=RGB(64,64,0);
const GREEN_OFF=RGB(0,64,0);

const RED_ON=RGB(255,0,0);
const YELLOW_ON=RGB(255,255,0);
const GREEN_ON=RGB(0,255,0);



CMySocket g_cSocket;
int g_iApplicationStep=1;
int g_iTimerIntervall=20000;



// Diese globale Struktur enthlt eine Reihe BOOLEAN Werte, die den Status der einzelnen
// Elemente reprsentieren. TRUE=ON, und FALSE=OFF. Der Inhalt dieser Struktur wird zum
// Darstellen der Kreuzung verwendet, somit muss nur der Inhalt verndert werden und dann
// das Fenster neugezeichnet werden, damit die nderungen wirksam sind. Der bestehende
// Quelltext muss nicht verndert werden.
struct SStatus
{
	// 4 BOOLEANs fr die Autos
	BOOLEAN bCarEast,bCarNorth,bCarWest,bCarSouth;
	// 2 BOOLEANs fr die Beeper
	BOOLEAN bBeeperSouthEast,bBeeperSouthWest;

	// 4 Strukturen mit je 3 BOOLEANs fr die 3 Lichter fr die 4 Ampeln
	struct SCarLight
	{
		BOOLEAN bRed,bYellow,bGreen;
	}CarLightNorth,CarLightSouth,CarLightWest,CarLightEast;

	// 8 Fugngerampeln mit je 2 BOOLEANs fr die 2 Lichter und einem BOOLEAN fr den Taster
	struct SWalkerLight
	{
		BOOLEAN bRed,bGreen;
		BOOLEAN bRequest;
	}WalkerLightSouthWest,WalkerLightSouthEast,WalkerLightNorthEast,WalkerLightNorthWest,
	 WalkerLightWestSouth,WalkerLightEastSouth,WalkerLightEastNorth,WalkerLightWestNorth;
}g_sStatus;






/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAmpelDlg Dialogfeld

CAmpelDlg::CAmpelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAmpelDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAmpelDlg)
	m_IP = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAmpelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAmpelDlg)
	DDX_Control(pDX, IDC_DISCONNECT, m_Disconnect);
	DDX_Control(pDX, IDC_CONNECT, m_Connect);
	DDX_Text(pDX, IDC_IP, m_IP);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAmpelDlg, CDialog)
	//{{AFX_MSG_MAP(CAmpelDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAmpelDlg Nachrichten-Handler

BOOL CAmpelDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen

	// Die Struktur mit allen Daten auf 0 setzen.
	// Alle BOOLEAN-Werte werden somit auf FALSE gesetzt und die Elemente deaktiviert
	FillMemory(&g_sStatus,sizeof(g_sStatus),0);

	g_cSocket.m_pAmpelDlg=this;

	return FALSE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CAmpelDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}



void DrawCarLight(CPaintDC &dc,int x,int y,COLORREF pos1,COLORREF pos2,COLORREF pos3,BOOLEAN bVertical)
{
	CBrush br_Pos1(pos1);
	CBrush br_Pos2(pos2);
	CBrush br_Pos3(pos3);

	dc.SelectStockObject(BLACK_PEN);

	if (bVertical)
	{
		dc.SelectStockObject(GRAY_BRUSH);
		dc.Rectangle(x,y,x+31,y+77);

		dc.SelectObject(br_Pos1);
		dc.Ellipse(x+5,y+3,x+26,y+24);
		
		dc.SelectObject(br_Pos2);
		dc.Ellipse(x+5,y+28,x+26,y+49);
		
		dc.SelectObject(br_Pos3);
		dc.Ellipse(x+5,y+53,x+26,y+74);
	}else{
		dc.SelectStockObject(GRAY_BRUSH);
		dc.Rectangle(x,y,x+77,y+31);

		dc.SelectObject(br_Pos1);
		dc.Ellipse(x+3,y+5,x+24,y+26);
		
		dc.SelectObject(br_Pos2);
		dc.Ellipse(x+28,y+5,x+49,y+26);
		
		dc.SelectObject(br_Pos3);
		dc.Ellipse(x+53,y+5,x+73,y+26);
	}
}

void DrawWalkerLight(CPaintDC &dc,int x,int y,COLORREF pos1,COLORREF pos2,BOOLEAN bVertical)
{
	CBrush br_Pos1(pos1);
	CBrush br_Pos2(pos2);

	dc.SelectStockObject(BLACK_PEN);

	if (bVertical)
	{
		dc.SelectStockObject(GRAY_BRUSH);
		dc.Rectangle(x,y,x+23,y+45);

		dc.SelectObject(br_Pos1);
		dc.Ellipse(x+3,y+4,x+20,y+21);
		
		dc.SelectObject(br_Pos2);
		dc.Ellipse(x+3,y+24,x+20,y+41);
	}else{
		dc.SelectStockObject(GRAY_BRUSH);
		dc.Rectangle(x,y,x+45,y+23);

		dc.SelectObject(br_Pos1);
		dc.Ellipse(x+4,y+3,x+21,y+20);
		
		dc.SelectObject(br_Pos2);
		dc.Ellipse(x+24,y+3,x+41,y+20);
	}
}



void CAmpelDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		// DeviceContext fr das Fenster, und einen SpeicherContext erstellen.
		// Der SpeicherContext wird gebraucht, um die Bitmaps anzuzeigen.

		CPaintDC dc(this);
		CDC memdc;
		memdc.CreateCompatibleDC(&dc);

		// Variablen fr Bitmaps, die spter geladen und angezeigt werden.
		CBitmap bm_Layout;
		CBitmap bm_CarWest,bm_CarNorth,bm_CarEast,bm_CarSouth;
		CBitmap bm_BeeperSouthWest,bm_BeeperSouthEast;

		// Bitmaps fr das Layout und die 4 Autos laden
		bm_Layout.LoadBitmap(IDB_LAYOUT);
		bm_CarWest.LoadBitmap(IDB_CARWEST);
		bm_CarNorth.LoadBitmap(IDB_CARNORTH);
		bm_CarEast.LoadBitmap(IDB_CAREAST);
		bm_CarSouth.LoadBitmap(IDB_CARSOUTH);

		// Layout malen
		memdc.SelectObject(&bm_Layout);
		dc.BitBlt(0,0,790,676,&memdc,0,0,SRCCOPY);

		// Auto Rechts
		memdc.SelectObject(&bm_CarEast);
		if (g_sStatus.bCarEast) 
			dc.BitBlt(608,240,137,65,&memdc,0,0,SRCCOPY);

		// Auto Oben
		memdc.SelectObject(&bm_CarNorth);
		if (g_sStatus.bCarNorth)
			dc.BitBlt(320,-16,65,137,&memdc,0,0,SRCCOPY);

		// Auto Links
		memdc.SelectObject(&bm_CarWest);
		if (g_sStatus.bCarWest) 
			dc.BitBlt(56,344,137,65,&memdc,0,0,SRCCOPY);

		// Auto Unten
		memdc.SelectObject(&bm_CarSouth);
		if (g_sStatus.bCarSouth) 
			dc.BitBlt(416,528,65,173,&memdc,0,0,SRCCOPY);

		// Autoampel Oben
		DrawCarLight(dc,258,44,	
			g_sStatus.CarLightNorth.bGreen?GREEN_ON:GREEN_OFF,
			g_sStatus.CarLightNorth.bYellow?YELLOW_ON:YELLOW_OFF,
			g_sStatus.CarLightNorth.bRed?RED_ON:RED_OFF,
			TRUE);

		// Autoampel Unten
		DrawCarLight(dc,508,524,
			g_sStatus.CarLightSouth.bRed?RED_ON:RED_OFF,
			g_sStatus.CarLightSouth.bYellow?YELLOW_ON:YELLOW_OFF,
			g_sStatus.CarLightSouth.bGreen?GREEN_ON:GREEN_OFF,
			TRUE);

		// Autoampel Links
		DrawCarLight(dc,120,432,
			g_sStatus.CarLightWest.bGreen?GREEN_ON:GREEN_OFF,
			g_sStatus.CarLightWest.bYellow?YELLOW_ON:YELLOW_OFF,
			g_sStatus.CarLightWest.bRed?RED_ON:RED_OFF,
			FALSE);

		// Autoampel Unten
		DrawCarLight(dc,600,184,
			g_sStatus.CarLightEast.bRed?RED_ON:RED_OFF,
			g_sStatus.CarLightEast.bYellow?YELLOW_ON:YELLOW_OFF,
			g_sStatus.CarLightEast.bGreen?GREEN_ON:GREEN_OFF,
			FALSE);

		// Fugngerampel links oben, vertikal
		DrawWalkerLight(dc,212,160,
			g_sStatus.WalkerLightNorthEast.bRed?RED_ON:RED_OFF,
			g_sStatus.WalkerLightNorthEast.bGreen?GREEN_ON:GREEN_OFF,
			TRUE);
		// Fugngerampel rechts oben, vertikal
		DrawWalkerLight(dc,562,160,			
			g_sStatus.WalkerLightNorthWest.bRed?RED_ON:RED_OFF,
			g_sStatus.WalkerLightNorthWest.bGreen?GREEN_ON:GREEN_OFF,
			TRUE);

		// Fugngerampel links unten, vertikal
		DrawWalkerLight(dc,212,444,			
			g_sStatus.WalkerLightSouthWest.bGreen?GREEN_ON:GREEN_OFF,
			g_sStatus.WalkerLightSouthWest.bRed?RED_ON:RED_OFF,
			TRUE);
		// Fugngerampel rechts unten, vertikal
		DrawWalkerLight(dc,562,444,			
			g_sStatus.WalkerLightSouthEast.bGreen?GREEN_ON:GREEN_OFF,
			g_sStatus.WalkerLightSouthEast.bRed?RED_ON:RED_OFF,
			TRUE);

		// Fugngerampel links oben, horizontal
		DrawWalkerLight(dc,238,132,			
			g_sStatus.WalkerLightWestNorth.bRed?RED_ON:RED_OFF,
			g_sStatus.WalkerLightWestNorth.bGreen?GREEN_ON:GREEN_OFF,
			FALSE);
		// Fugngerampel links unten, horizontal
		DrawWalkerLight(dc,238,496,			
			g_sStatus.WalkerLightWestSouth.bRed?RED_ON:RED_OFF,
			g_sStatus.WalkerLightWestSouth.bGreen?GREEN_ON:GREEN_OFF,
			FALSE);

		// Fugngerampel rechts oben, horizontal
		DrawWalkerLight(dc,514,132,			
			g_sStatus.WalkerLightEastNorth.bGreen?GREEN_ON:GREEN_OFF,
			g_sStatus.WalkerLightEastNorth.bRed?RED_ON:RED_OFF,
			FALSE);
		// Fugngerampel rechts unten, horizontal
		DrawWalkerLight(dc,514,496,			
			g_sStatus.WalkerLightEastSouth.bGreen?GREEN_ON:GREEN_OFF,
			g_sStatus.WalkerLightEastSouth.bRed?RED_ON:RED_OFF,
			FALSE);

		// Die 8 Taster malen
		CPen pen(PS_SOLID,1,RGB(128,128,128));
		dc.SelectObject(pen);

		// Taster links oben, vertikal
		dc.SelectStockObject(g_sStatus.WalkerLightNorthWest.bRequest?LTGRAY_BRUSH:BLACK_BRUSH);
		dc.Ellipse(212+4,160+48,212+4+15,160+48+15);

		// Taster rechts oben, vertikal
		dc.SelectStockObject(g_sStatus.WalkerLightNorthEast.bRequest?LTGRAY_BRUSH:BLACK_BRUSH);
		dc.Ellipse(562+4,160+48,562+4+15,160+48+15);

		// Taster links unten, vertikal
		dc.SelectStockObject(g_sStatus.WalkerLightSouthWest.bRequest?LTGRAY_BRUSH:BLACK_BRUSH);
		dc.Ellipse(212+4,425,212+4+15,425+15);

		// Taster rechts unten, vertikal
		dc.SelectStockObject(g_sStatus.WalkerLightSouthEast.bRequest?LTGRAY_BRUSH:BLACK_BRUSH);
		dc.Ellipse(562+4,425,562+4+15,425+15);

		// Taster links oben, horizontal
		dc.SelectStockObject(g_sStatus.WalkerLightWestNorth.bRequest?LTGRAY_BRUSH:BLACK_BRUSH);
		dc.Ellipse(238+45,132+4,238+45+15,132+4+15);

		// Taster links unten, horizontal
		dc.SelectStockObject(g_sStatus.WalkerLightWestSouth.bRequest?LTGRAY_BRUSH:BLACK_BRUSH);
		dc.Ellipse(238+45,496+4,238+45+15,496+4+15);

		// Taster rechts oben, horizontal
		dc.SelectStockObject(g_sStatus.WalkerLightEastNorth.bRequest?LTGRAY_BRUSH:BLACK_BRUSH);
		dc.Ellipse(498,132+4,498+15,132+4+15);

		// Taster rechts unten, vertikal
		dc.SelectStockObject(g_sStatus.WalkerLightEastSouth.bRequest?LTGRAY_BRUSH:BLACK_BRUSH);
		dc.Ellipse(498,496+4,498+15,496+4+15);

		// Beeper rechts unten malen
		if (g_sStatus.bBeeperSouthEast)
			bm_BeeperSouthEast.LoadBitmap(IDB_BEEPER_SOUTHEAST_ON);
		else bm_BeeperSouthEast.LoadBitmap(IDB_BEEPER_SOUTHEAST_OFF);

		memdc.SelectObject(bm_BeeperSouthEast);
		dc.BitBlt(600,432,57,65,&memdc,0,0,SRCCOPY);

		// Beeper links unten malen
		if (g_sStatus.bBeeperSouthEast)
			bm_BeeperSouthWest.LoadBitmap(IDB_BEEPER_SOUTHWEST_ON);
		else bm_BeeperSouthWest.LoadBitmap(IDB_BEEPER_SOUTHWEST_OFF);

		memdc.SelectObject(bm_BeeperSouthWest);
		dc.BitBlt(224,528,57,65,&memdc,0,0,SRCCOPY);
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CAmpelDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAmpelDlg::OnConnect() 
{
	UpdateData();

	g_cSocket.Create();
	if (g_cSocket.Connect(m_IP,80) == FALSE)
	{
		g_cSocket.Close();
		MessageBox("Verbindung fehlgeschlagen");
		return;
	}

	SetTimer(1,100,NULL);
	SetTimer(2,g_iTimerIntervall / 10,NULL);

	m_Connect.EnableWindow(FALSE);
	m_Disconnect.EnableWindow(TRUE);
}

void CAmpelDlg::OnDisconnect() 
{
	KillTimer(1);
	KillTimer(2);

	g_cSocket.Close();

	m_Connect.EnableWindow(TRUE);
	m_Disconnect.EnableWindow(FALSE);
}

void CAmpelDlg::OnDestroy() 
{
	CDialog::OnDestroy();

	if (g_cSocket.m_hSocket != -1)
	{   
		KillTimer(1);
		KillTimer(2);
		g_cSocket.Close();
	}
}

void CAmpelDlg::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent==1)
	{
		CString sRequest;
		sRequest="GET /input?PW=&";

		g_cSocket.Send(sRequest,sRequest.GetLength());
	}
	if (nIDEvent==2)
	{
		CString sCommand;
		if (g_iApplicationStep==1)
		{
			g_sStatus.CarLightEast.bRed=FALSE;
			g_sStatus.CarLightEast.bYellow=TRUE;
			g_sStatus.CarLightEast.bGreen=FALSE;

			g_sStatus.CarLightWest.bRed=FALSE;
			g_sStatus.CarLightWest.bYellow=TRUE;
			g_sStatus.CarLightWest.bGreen=FALSE;

			g_sStatus.WalkerLightNorthEast.bGreen=FALSE;
			g_sStatus.WalkerLightNorthEast.bRed=TRUE;
			g_sStatus.WalkerLightSouthEast.bGreen=FALSE;
			g_sStatus.WalkerLightSouthEast.bRed=TRUE;
			g_sStatus.WalkerLightNorthWest.bGreen=FALSE;
			g_sStatus.WalkerLightNorthWest.bRed=TRUE;
			g_sStatus.WalkerLightSouthWest.bGreen=FALSE;
			g_sStatus.WalkerLightSouthWest.bRed=TRUE;
	
			SetTimer(2,g_iTimerIntervall / 10,NULL);
			sCommand="GET /outputaccess?PW=&State=0012&";
		}
		if (g_iApplicationStep==2)
		{
			g_sStatus.CarLightEast.bRed=TRUE;
			g_sStatus.CarLightEast.bYellow=FALSE;

			g_sStatus.CarLightWest.bRed=TRUE;
			g_sStatus.CarLightWest.bYellow=FALSE;
			sCommand="GET /outputaccess?PW=&State=0014&";
		}

		if (g_iApplicationStep==3)
		{
			g_sStatus.WalkerLightNorthEast.bGreen=TRUE;
			g_sStatus.WalkerLightNorthEast.bRed=FALSE;
			g_sStatus.WalkerLightSouthEast.bGreen=TRUE;
			g_sStatus.WalkerLightSouthEast.bRed=FALSE;
			g_sStatus.WalkerLightNorthWest.bGreen=TRUE;
			g_sStatus.WalkerLightNorthWest.bRed=FALSE;
			g_sStatus.WalkerLightSouthWest.bGreen=TRUE;
			g_sStatus.WalkerLightSouthWest.bRed=FALSE;

			SetTimer(2,g_iTimerIntervall,NULL);
			sCommand="GET /outputaccess?PW=&State=000C&";
		}
		if (g_iApplicationStep==4)
		{
			g_sStatus.WalkerLightNorthEast.bGreen=FALSE;
			g_sStatus.WalkerLightNorthEast.bRed=TRUE;
			g_sStatus.WalkerLightSouthEast.bGreen=FALSE;
			g_sStatus.WalkerLightSouthEast.bRed=TRUE;
			g_sStatus.WalkerLightNorthWest.bGreen=FALSE;
			g_sStatus.WalkerLightNorthWest.bRed=TRUE;
			g_sStatus.WalkerLightSouthWest.bGreen=FALSE;
			g_sStatus.WalkerLightSouthWest.bRed=TRUE;

			SetTimer(2,g_iTimerIntervall / 10,NULL);
			sCommand="GET /outputaccess?PW=&State=0014&";
		}
		if (g_iApplicationStep==5)
		{
			g_sStatus.CarLightEast.bYellow=TRUE;
			g_sStatus.CarLightWest.bYellow=TRUE;
			sCommand="GET /outputaccess?PW=&State=0016&";
		}
		if (g_iApplicationStep==6)
		{
			g_sStatus.CarLightEast.bRed=FALSE;
			g_sStatus.CarLightEast.bYellow=FALSE;
			g_sStatus.CarLightEast.bGreen=TRUE;

			g_sStatus.CarLightWest.bRed=FALSE;
			g_sStatus.CarLightWest.bYellow=FALSE;
			g_sStatus.CarLightWest.bGreen=TRUE;

			SetTimer(2,g_iTimerIntervall,NULL);
			sCommand="GET /outputaccess?PW=&State=0011&";
		}

		Invalidate(FALSE);
		g_cSocket.Send(sCommand,sCommand.GetLength());

		g_iApplicationStep++;
		if (g_iApplicationStep==7)g_iApplicationStep=1;
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CAmpelDlg::OnReceive()
{
	CString sData;
	int state;
	BOOLEAN on;

	g_cSocket.Receive(sData.GetBuffer(100),100);
	sData.ReleaseBuffer();

	if (sData.Left(6)=="input;")
	{
		sscanf(sData.Right(4),"%x",&state);

		on=(state & 0x0001);
		if (on!=g_sStatus.bCarWest)
		{
			g_sStatus.bCarWest=on;
			Invalidate(FALSE);
		}

		on=(state & 0x0002);
		if (on!=g_sStatus.bCarEast)
		{
			g_sStatus.bCarEast=on;
			Invalidate(FALSE);
		}

		on=(state & 0x0010);
		if (on!=g_sStatus.bCarNorth)
		{
			g_sStatus.bCarNorth=on;
			Invalidate(FALSE);
		}

		on=(state & 0x0020);
		if (on!=g_sStatus.bCarSouth)
		{
			g_sStatus.bCarSouth=on;
			Invalidate(FALSE);
		}

		on=(state & 0x0004);
		if (on!=g_sStatus.WalkerLightNorthWest.bRequest)
		{
			g_sStatus.WalkerLightNorthWest.bRequest=on;
			g_sStatus.WalkerLightSouthWest.bRequest=on;
			Invalidate(FALSE);
		}

		on=(state & 0x0008);
		if (on!=g_sStatus.WalkerLightNorthEast.bRequest)
		{
			g_sStatus.WalkerLightNorthEast.bRequest=on;
			g_sStatus.WalkerLightSouthEast.bRequest=on;
			Invalidate(FALSE);
		}

		on=(state & 0x0040);
		if (on!=g_sStatus.WalkerLightWestNorth.bRequest)
		{
			g_sStatus.WalkerLightWestNorth.bRequest=on;
			g_sStatus.WalkerLightEastNorth.bRequest=on;
			Invalidate(FALSE);
		}

		on=(state & 0x0080);
		if (on!=g_sStatus.WalkerLightWestSouth.bRequest)
		{
			g_sStatus.WalkerLightWestSouth.bRequest=on;
			g_sStatus.WalkerLightEastSouth.bRequest=on;
			Invalidate(FALSE);
		}
	}
}

