unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, ScktComp;

type
  Tfm_TrafficLight = class(TForm)
    im_junction: TImage;
    StatusBar1: TStatusBar;
    sh_CarNorth_Green: TShape;
    sh_CarNorth_Yellow: TShape;
    sh_CarNorth_Red: TShape;
    sh_TrafficLightNorth: TShape;
    sh_WalkerNorthWest_Green: TShape;
    sh_WalkerNorthWest_Red: TShape;
    sh_TrafficLightNorthWest: TShape;
    sh_RequestNorthWest: TShape;
    sh_WalkerWestNorth_Red: TShape;
    sh_WalkerWestNorth_Green: TShape;
    sh_TrafficLightWestNorth: TShape;
    sh_RequestWestNorth: TShape;
    sh_RequestNorthEast: TShape;
    sh_TrafficLightNorthEast: TShape;
    sh_WalkerNorthEast_Green: TShape;
    sh_WalkerNorthEast_Red: TShape;
    sh_TrafficLightEastNorth: TShape;
    sh_WalkerEastNorth_Red: TShape;
    sh_WalkerEastNorth_Green: TShape;
    sh_RequestEastNorth: TShape;
    sh_TrafficLightEast: TShape;
    sh_CarEast_Red: TShape;
    sh_CarEast_Yellow: TShape;
    sh_CarEast_Green: TShape;
    sh_TrafficLightWest: TShape;
    sh_CarWest_Green: TShape;
    sh_CarWest_Yellow: TShape;
    sh_CarWest_Red: TShape;
    sh_RequestWestSouth: TShape;
    sh_TrafficLightWestSouth: TShape;
    sh_WalkerWestSouth_Green: TShape;
    sh_WalkerWestSouth_Red: TShape;
    sh_TrafficLightSouthWest: TShape;
    sh_WalkerSouthWest_Red: TShape;
    sh_WalkerSouthWest_Green: TShape;
    sh_RequestSouthWest: TShape;
    sh_RequestSouthEast: TShape;
    sh_RequestEastSouth: TShape;
    sh_TrafficLightSouthEast: TShape;
    sh_WalkerSouthEast_Green: TShape;
    sh_WalkerSouthEast_Red: TShape;
    sh_TrafficLightEastSouth: TShape;
    sh_WalkerEastSouth_Red: TShape;
    sh_WalkerEastSouth_Green: TShape;
    sh_TrafficLightSouth: TShape;
    sh_CarSouth_Red: TShape;
    sh_CarSouth_Yellow: TShape;
    sh_CarSouth_Green: TShape;
    im_Compass: TImage;
    im_CarNorth: TImage;
    im_CarEast: TImage;
    im_CarSouth: TImage;
    im_CarWest: TImage;
    im_BeeberSouthWest_On: TImage;
    im_BeeperSouthWest_OFF: TImage;
    im_BeeperEastSouth_On: TImage;
    im_BeeperEastSouth_Off: TImage;
    lb_board1: TLabel;
    lb_board2: TLabel;
    gb_config: TGroupBox;
    lb_ip: TLabel;
    lb_port: TLabel;
    ed_ip: TEdit;
    ed_port: TEdit;
    bt_connect: TButton;
    bt_disconnect: TButton;
    bt_on: TButton;
    bt_off: TButton;
    ClientSocket1: TClientSocket;
    procedure bt_connectClick(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure bt_onClick(Sender: TObject);
    procedure bt_offClick(Sender: TObject);
    procedure bt_disconnectClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const
  BIT0=1;
  BIT1=2;
  BIT2=4;
  BIT3=8;
  BIT4=16;
  BIT5=32;
  BIT6=64;
  BIT7=128;
  BIT8=256;
  BIT9=512;
  BIT10=1024;
  BIT11=2048;

const
  BITSET : array [0..11] of word =
      ( BIT0, BIT1, BIT2, BIT3, BIT4, BIT5,  BIT6, BIT7, BIT8, BIT9, BIT10, BIT11);

const
RED_ON =  clRed;
RED_OFF = clMaroon;
YELLOW_ON = clYellow;
YELLOW_OFF = clOlive;
GREEN_ON = clLime;
GREEN_OFF = clGreen;
BLACK_ON = clSilver;
BLACK_OFF = clBlack;

var
  fm_TrafficLight: Tfm_TrafficLight;

implementation

{$R *.DFM}

procedure Tfm_TrafficLight.bt_connectClick(Sender: TObject);
begin
  if (ed_ip.Text <> '') and (ed_port.Text <> '') then
  begin
    ClientSocket1.Host := ed_ip.Text;
    ClientSocket1.Port := strtoint(ed_Port.Text);
    ClientSocket1.Active := True;
  end;
end;

procedure Tfm_TrafficLight.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  bt_connect.Enabled := False;
  bt_disconnect.Enabled := True;
  bt_on.Enabled := True;
  StatusBar1.SimpleText := 'connected';
end;

procedure Tfm_TrafficLight.bt_onClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('GET /outputaccess0?PW=&State=ON&');
  sh_CarWest_Green.Brush.Color := GREEN_ON;
  sh_CarEast_Green.Brush.Color := GREEN_ON;
  bt_on.Enabled := False;
  bt_off.Enabled := True;
end;

procedure Tfm_TrafficLight.bt_offClick(Sender: TObject);
begin
  ClientSocket1.Socket.SendText('GET /outputaccess0?PW=&State=OFF&');
  sh_CarWest_Green.Brush.Color := GREEN_OFF;
  sh_CarEast_Green.Brush.Color := GREEN_OFF;
  bt_on.Enabled := True;
  bt_off.Enabled := False;
end;

procedure Tfm_TrafficLight.bt_disconnectClick(Sender: TObject);
begin
  ClientSocket1.Active := False;
  bt_connect.Enabled := True;
  bt_disconnect.Enabled := False;
  bt_on.Enabled := False;
  bt_off.Enabled := False;
  StatusBar1.SimpleText := 'disconnected';
end;


end.
