unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, ScktComp;

type
  Tfm_TrafficLight = class(TForm)
    im_junction: TImage;
    StatusBar1: TStatusBar;
    sh_CarNorth_Green: TShape;
    sh_CarNorth_Yellow: TShape;
    sh_CarNorth_Red: TShape;
    sh_TrafficLightNorth: TShape;
    sh_WalkerNorthWest_Green: TShape;
    sh_WalkerNorthWest_Red: TShape;
    sh_TrafficLightNorthWest: TShape;
    sh_RequestNorthWest: TShape;
    sh_WalkerWestNorth_Red: TShape;
    sh_WalkerWestNorth_Green: TShape;
    sh_TrafficLightWestNorth: TShape;
    sh_RequestWestNorth: TShape;
    sh_RequestNorthEast: TShape;
    sh_TrafficLightNorthEast: TShape;
    sh_WalkerNorthEast_Green: TShape;
    sh_WalkerNorthEast_Red: TShape;
    sh_TrafficLightEastNorth: TShape;
    sh_WalkerEastNorth_Red: TShape;
    sh_WalkerEastNorth_Green: TShape;
    sh_RequestEastNorth: TShape;
    sh_TrafficLightEast: TShape;
    sh_CarEast_Red: TShape;
    sh_CarEast_Yellow: TShape;
    sh_CarEast_Green: TShape;
    sh_TrafficLightWest: TShape;
    sh_CarWest_Green: TShape;
    sh_CarWest_Yellow: TShape;
    sh_CarWest_Red: TShape;
    sh_RequestWestSouth: TShape;
    sh_TrafficLightWestSouth: TShape;
    sh_WalkerWestSouth_Green: TShape;
    sh_WalkerWestSouth_Red: TShape;
    sh_TrafficLightSouthWest: TShape;
    sh_WalkerSouthWest_Red: TShape;
    sh_WalkerSouthWest_Green: TShape;
    sh_RequestSouthWest: TShape;
    sh_RequestSouthEast: TShape;
    sh_RequestEastSouth: TShape;
    sh_TrafficLightSouthEast: TShape;
    sh_WalkerSouthEast_Green: TShape;
    sh_WalkerSouthEast_Red: TShape;
    sh_TrafficLightEastSouth: TShape;
    sh_WalkerEastSouth_Red: TShape;
    sh_WalkerEastSouth_Green: TShape;
    sh_TrafficLightSouth: TShape;
    sh_CarSouth_Red: TShape;
    sh_CarSouth_Yellow: TShape;
    sh_CarSouth_Green: TShape;
    im_Compass: TImage;
    im_CarNorth: TImage;
    im_CarEast: TImage;
    im_CarSouth: TImage;
    im_CarWest: TImage;
    im_BeeberSouthWest_On: TImage;
    im_BeeperSouthWest_OFF: TImage;
    im_BeeperEastSouth_On: TImage;
    im_BeeperEastSouth_Off: TImage;
    lb_board1: TLabel;
    lb_board2: TLabel;
    gb_config: TGroupBox;
    lb_ip: TLabel;
    lb_port: TLabel;
    ed_ip: TEdit;
    ed_port: TEdit;
    bt_connect: TButton;
    bt_disconnect: TButton;
    bt_apply: TButton;
    ed_interval: TEdit;
    lb_interval: TLabel;
    lb_ms: TLabel;
    Timer1: TTimer;
    ClientSocket1: TClientSocket;
    procedure bt_connectClick(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Timer1Timer(Sender: TObject);
    procedure bt_applyClick(Sender: TObject);
    procedure bt_disconnectClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

const
RED_ON =  clRed;
RED_OFF = clMaroon;
YELLOW_ON = clYellow;
YELLOW_OFF = clOlive;
GREEN_ON = clLime;
GREEN_OFF = clGreen;
BLACK_ON = clSilver;
BLACK_OFF = clBlack;

var
  fm_TrafficLight          : Tfm_TrafficLight;
  vin_applicationstep      : Integer;
  vin_interval             : Integer;
  vbo_disconnectquiry     : boolean;
  vbo_closequiry           : boolean;

implementation

{$R *.DFM}

procedure Tfm_TrafficLight.bt_connectClick(Sender: TObject);
begin
  if (ed_ip.Text <> '') and (ed_port.Text <> '') then
  begin
    ClientSocket1.Host := ed_ip.Text;
    ClientSocket1.Port := strtoint(ed_Port.Text);
    ClientSocket1.Active := True;
  end;
end;

procedure Tfm_TrafficLight.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  bt_connect.Enabled := False;
  bt_disconnect.Enabled := True;
  StatusBar1.SimpleText := 'connected';
  Timer1.Interval := vin_interval div 10;
  Timer1.Enabled := True;
end;

procedure Tfm_TrafficLight.Timer1Timer(Sender: TObject);
begin
  case vin_applicationstep of

       1: begin
            if vbo_disconnectquiry then
            begin
              Timer1.Enabled := False;
              sh_CarWest_Green.Brush.Color := GREEN_OFF;
              sh_CarEast_Green.Brush.Color := GREEN_OFF;
              sh_WalkerWestNorth_Red.Brush.Color := RED_OFF;
              sh_WalkerWestSouth_Red.Brush.Color := RED_OFF;
              sh_WalkerEastNorth_Red.Brush.Color := RED_OFF;
              sh_WalkerEastSouth_Red.Brush.Color := RED_OFF;
              ClientSocket1.Socket.SendText('GET /outputaccess?PW=&State=0000&');
              sleep(50);
              ClientSocket1.Active := False;
              StatusBar1.SimpleText := 'disconnected';
              bt_connect.Enabled := True;
              if vbo_closequiry then close;
              vbo_disconnectquiry := False;
            end
            else
            begin
              sh_CarWest_Green.Brush.Color := GREEN_OFF;
              sh_CarWest_Yellow.Brush.Color := YELLOW_ON;
              sh_CarEast_Green.Brush.Color := GREEN_OFF;
              sh_CarEast_Yellow.Brush.Color := YELLOW_ON;
              sh_WalkerWestNorth_Green.Brush.Color := GREEN_OFF;
              sh_WalkerWestNorth_Red.Brush.Color := RED_ON;
              sh_WalkerWestSouth_Green.Brush.Color := GREEN_OFF;
              sh_WalkerWestSouth_Red.Brush.Color := RED_ON;
              sh_WalkerEastNorth_Green.Brush.Color := GREEN_OFF;
              sh_WalkerEastNorth_Red.Brush.Color := RED_ON;
              sh_WalkerEastSouth_Green.Brush.Color := GREEN_OFF;
              sh_WalkerEastSouth_Red.Brush.Color := RED_ON;
              ClientSocket1.Socket.SendText('GET /outputaccess?PW=&State=0012&');
              Timer1.Interval := vin_interval div 10;
              inc(vin_applicationstep);
            end;  
          end;
       2: begin
            sh_CarWest_Yellow.Brush.Color := YELLOW_OFF;
            sh_CarWest_Red.Brush.Color := RED_ON;
            sh_CarEast_Yellow.Brush.Color := YELLOW_OFF;
            sh_CarEast_Red.Brush.Color := RED_ON;
            ClientSocket1.Socket.SendText('GET /outputaccess?PW=&State=0014&');
            inc(vin_applicationstep);
          end;
       3: begin
            sh_WalkerWestNorth_Green.Brush.Color := GREEN_ON;
            sh_WalkerWestNorth_Red.Brush.Color := RED_OFF;
            sh_WalkerWestSouth_Green.Brush.Color := GREEN_ON;
            sh_WalkerWestSouth_Red.Brush.Color := RED_OFF;
            sh_WalkerEastNorth_Green.Brush.Color := GREEN_ON;
            sh_WalkerEastNorth_Red.Brush.Color := RED_OFF;
            sh_WalkerEastSouth_Green.Brush.Color := GREEN_ON;
            sh_WalkerEastSouth_Red.Brush.Color := RED_OFF;
            ClientSocket1.Socket.SendText('GET /outputaccess?PW=&State=000C&');
            Timer1.Interval := vin_interval;
            inc(vin_applicationstep);
          end;
       4: begin
            sh_WalkerWestNorth_Green.Brush.Color := GREEN_OFF;
            sh_WalkerWestNorth_Red.Brush.Color := RED_ON;
            sh_WalkerWestSouth_Green.Brush.Color := GREEN_OFF;
            sh_WalkerWestSouth_Red.Brush.Color := RED_ON;
            sh_WalkerEastNorth_Green.Brush.Color := GREEN_OFF;
            sh_WalkerEastNorth_Red.Brush.Color := RED_ON;
            sh_WalkerEastSouth_Green.Brush.Color := GREEN_OFF;
            sh_WalkerEastSouth_Red.Brush.Color := RED_ON;
            ClientSocket1.Socket.SendText('GET /outputaccess?PW=&State=0014&');
            Timer1.Interval := vin_interval div 10;
            inc(vin_applicationstep);
          end;
       5: begin
            sh_CarWest_Yellow.Brush.Color := YELLOW_ON;
            sh_CarEast_Yellow.Brush.Color := YELLOW_ON;
            ClientSocket1.Socket.SendText('GET /outputaccess?PW=&State=0016&');
            inc(vin_applicationstep);
          end;
       6: begin
            sh_CarWest_Green.Brush.Color := GREEN_ON;
            sh_CarWest_Yellow.Brush.Color := YELLOW_OFF;
            sh_CarWest_Red.Brush.Color := RED_OFF;
            sh_CarEast_Green.Brush.Color := GREEN_ON;
            sh_CarEast_Yellow.Brush.Color := YELLOW_OFF;
            sh_CarEast_Red.Brush.Color := RED_OFF;
            ClientSocket1.Socket.SendText('GET /outputaccess?PW=&State=0011&');
            if vbo_disconnectquiry then
              Timer1.Interval := vin_interval div 10
            else
              Timer1.Interval := vin_interval;
            vin_applicationstep := 1;
          end;
        end;
end;

procedure Tfm_TrafficLight.bt_applyClick(Sender: TObject);
begin
  vin_interval := strtoint(ed_interval.Text);
end;

procedure Tfm_TrafficLight.bt_disconnectClick(Sender: TObject);
begin
  vbo_disconnectquiry :=True;
  bt_disconnect.Enabled := False;
  StatusBar1.SimpleText := 'waiting for disconnect';
end;

procedure Tfm_TrafficLight.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if ClientSocket1.Active = True then
  begin
    CanClose := False;
    vbo_closequiry := True;
    vbo_disconnectquiry :=True;
    StatusBar1.SimpleText := 'waiting for disconnect';
  end
  else CanClose := True;
end;

procedure Tfm_TrafficLight.FormCreate(Sender: TObject);
begin
  vin_applicationstep := 1;
  vin_interval := strtoint(ed_interval.Text);
  Timer1.Interval := vin_interval div 10;
end;

end.
